System.register(["tslib", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/core/Command"], function (_export, _context) {
  "use strict";

  var __awaiter, CancelToken, PageCommands, PageNavigator;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistCoreCommand) {
      PageCommands = _webAtomsCoreDistCoreCommand.PageCommands;
    }],
    execute: function () {
      _export("default", PageNavigator = class PageNavigator {
        static openPage(page, parameters = {}, clearHistory = true) {
          this.pushPageForResult(page, parameters, clearHistory).catch(e => {
            if (!CancelToken.isCancelled(e)) {
              console.error(e);
            }
          });
        }
        static pushPage(page, parameters = {}, clearHistory = false) {
          this.pushPageForResult(page, parameters, clearHistory).catch(e => {
            if (!CancelToken.isCancelled(e)) {
              console.error(e);
            }
          });
        }
        static pushPageForResult(page_1) {
          return __awaiter(this, arguments, void 0, function* (page, parameters = {}, clearHistory = false) {
            return null;
          });
        }
        static pushPageForResultOrCancel(page, parameters, clearHistory) {
          try {
            return this.pushPageForResult(page, parameters);
          } catch (e) {
            if (CancelToken.isCancelled(e)) {
              return;
            }
            console.error(e);
            return;
          }
        }
      });
      PageCommands.openPage = (c, p) => PageNavigator.openPage(c, p);
      PageCommands.pushPage = (c, p) => PageNavigator.pushPage(c, p);
      PageCommands.pushPageForResult = (c, p) => PageNavigator.pushPageForResult(c, p);
    }
  };
});
//# sourceMappingURL=PageNavigator.js.map