System.register(["tslib", "@web-atoms/core/dist/Atom", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/services/NavigationService", "@web-atoms/core/dist/services/ReferenceService", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/controls/AtomTemplateControl", "@web-atoms/core/dist/web/services/WindowService", "./AutoCompleteBoxStyle", "./ItemHost"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, Atom, Bind, BindableProperty, CancelToken, XNode, NavigationService, ReferenceService, AtomControl, AtomTemplateControl, WindowService, AutoCompleteBoxStyle, ItemHost, AutoCompleteBox, KeyCodes;
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistAtom) {
      Atom = _webAtomsCoreDistAtom.Atom;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistServicesNavigationService) {
      NavigationService = _webAtomsCoreDistServicesNavigationService.NavigationService;
    }, function (_webAtomsCoreDistServicesReferenceService) {
      ReferenceService = _webAtomsCoreDistServicesReferenceService.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebControlsAtomTemplateControl) {
      AtomTemplateControl = _webAtomsCoreDistWebControlsAtomTemplateControl.AtomTemplateControl;
    }, function (_webAtomsCoreDistWebServicesWindowService) {
      WindowService = _webAtomsCoreDistWebServicesWindowService.WindowService;
    }, function (_AutoCompleteBoxStyle) {
      AutoCompleteBoxStyle = _AutoCompleteBoxStyle.default;
    }, function (_ItemHost) {
      ItemHost = _ItemHost.default;
    }],
    execute: function () {
      (function (KeyCodes) {
        KeyCodes["Enter"] = "Enter";
        KeyCodes["ArrowDown"] = "ArrowDown";
        KeyCodes["ArrowUp"] = "ArrowUp";
        KeyCodes["ArrowLeft"] = "ArrowLeft";
        KeyCodes["ArrowRight"] = "ArrowRight";
        KeyCodes["End"] = "End";
        KeyCodes["Home"] = "Home";
        KeyCodes["Escape"] = "Escape";
      })(KeyCodes || (KeyCodes = {}));
      AutoCompleteBox = class AutoCompleteBox extends AtomControl {
        onPropertyChanged(name) {
          switch (name) {
            case "searchText":
            case "value":
              this.onSearchTextChanged(true);
              break;
            case "selectedItem":
              const si = this.selectedItem;
              const vf = this.valueFunc;
              if (vf && si) {
                this.value = vf(si);
              }
              break;
          }
        }
        onUpdateUI() {
          super.onUpdateUI();
          if (this.created) {
            return;
          }
          const openPopup = () => this.app.runAsync(() => __awaiter(this, void 0, void 0, function* () {
            yield Atom.delay(200);
            yield this.openPopup(true);
          }));
          this.render(XNode.create("div", {
            styleClass: Bind.oneWay(() => ({
              [this.controlStyle.name]: 1,
              "popup-open": this.isPopupOpen || !this.value
            }))
          }, XNode.create("input", {
            type: "search",
            autocomplete: "none",
            eventFocus: openPopup,
            eventClick: openPopup,
            value: Bind.twoWays(() => this.searchText, ["keyup", "keypress", "keydown"]),
            placeholder: Bind.oneWay(() => this.label),
            eventKeydown: e => this.onKey(e),
            eventBlur: () => setTimeout(() => {
              var _a;
              return (_a = this.cancelToken) === null || _a === void 0 ? void 0 : _a.cancel();
            }, 100)
          }), XNode.create(AtomTemplateControl, {
            class: "item-template",
            contentTemplate: Bind.oneWay(() => this.itemTemplate),
            data: Bind.oneWay(() => this.selectedItem)
          })));
        }
        hasProperty(name) {
          if (/^(data|selectedItem|itemTemplate|isPopupOpen|value|localViewModel|viewModel)$/.test(name)) {
            return true;
          }
          return super.hasProperty(name);
        }
        onSearchTextChanged(force = false) {
          var _a;
          if (this.isUpdating) {
            return;
          }
          if (!force) {
            if (this.lastSearchText === this.searchText) {
              return;
            }
            this.lastSearchText = this.searchText;
          }
          setTimeout(() => {
            this.app.runAsync(() => this.openPopup());
          }, 10);
          if (!this.itemsSource) {
            console.warn("No itemsSource defined");
            return;
          }
          const s = this.searchText || this.value;
          if (!s) {
            return;
          }
          (_a = this.cancelToken) === null || _a === void 0 ? void 0 : _a.cancel();
          const c = new CancelToken();
          this.cancelToken = c;
          this.runAsync(() => __awaiter(this, void 0, void 0, function* () {
            yield Atom.delay(250, c);
            if (c.cancelled) {
              return;
            }
            const result = this.itemsSource({
              search: this.searchText,
              cancel: c,
              value: this.value
            });
            if (!result) {
              return;
            }
            const rp = result;
            if (rp.then && rp.catch) {
              try {
                const items = yield rp;
                if (c.cancelled) {
                  return;
                }
                this.items.replace(items || []);
              } catch (ex) {
                c.cancel();
              }
            } else {
              const items = result;
              if (c.cancelled) {
                return;
              }
              this.items.replace(items || []);
            }
            if (!this.selectedItem) {
              const first = this.items[0];
              if (first) {
                const v1 = this.valueFunc ? this.valueFunc(first) : first;
                if (v1 == this.value) {
                  this.selectedItem = first;
                  this.element.dispatchEvent(new CustomEvent("item-selected", {
                    cancelable: false,
                    bubbles: false,
                    detail: this.selectedItem
                  }));
                }
              }
            }
          }));
        }
        runAsync(fx) {
          this.app.runAsync(() => __awaiter(this, void 0, void 0, function* () {
            try {
              yield fx();
            } catch (e) {
              const s = e.message || e.toString();
              if (s === "cancelled") {
                return;
              }
              console.error(e);
            }
          }));
        }
        preCreate() {
          this.itemTemplate = null;
          this.items = [];
          this.itemsSource = null;
          this.label = null;
          this.lastSearchText = null;
          this.lastValue = null;
          this.value = null;
          this.isPopupOpen = false;
          this.valueFunc = null;
          this.itemHostTemplate = ItemHost;
          this.searchText = null;
          this.lastSearchText = null;
          this.lastValue = null;
          this.created = false;
          this.isUpdating = false;
          this.defaultControlStyle = AutoCompleteBoxStyle;
        }
        create() {}
        onKey(e) {
          if (!this.isPopupOpen) {
            return;
          }
          switch (e.key) {
            case KeyCodes.Enter:
              if (this.windowViewModel) {
                this.element.dispatchEvent(new CustomEvent("item-selected", {
                  cancelable: false,
                  bubbles: false,
                  detail: this.selectedItem
                }));
                this.windowViewModel.close(this.selectedItem);
                this.windowViewModel = null;
              }
              break;
            case KeyCodes.Escape:
              if (this.windowViewModel) {
                this.windowViewModel.cancel();
                this.windowViewModel = null;
              }
              break;
            case KeyCodes.ArrowUp:
              this.moveSelection(-1);
              break;
            case KeyCodes.ArrowDown:
              this.moveSelection(+1);
              break;
          }
        }
        moveSelection(n) {
          try {
            this.isUpdating = true;
            if (!this.items) {
              return;
            }
            const index = this.items.indexOf(this.selectedItem);
            if (index === -1) {
              if (n > 0 && this.items.length) {
                this.selectedItem = this.items[0];
              }
              return;
            }
            const newIndex = index + n;
            if (newIndex < 0 || newIndex >= this.items.length) {
              return;
            }
            this.selectedItem = this.items[newIndex];
          } finally {
            this.isUpdating = false;
          }
        }
        openPopup() {
          return __awaiter(this, arguments, void 0, function* (force = false) {
            if (this.isPopupOpen) {
              return;
            }
            try {
              if (!force) {
                if (!this.searchText) {
                  return;
                }
              }
              this.isPopupOpen = true;
              this.onSearchTextChanged();
              const rs = this.app.get(ReferenceService);
              const ws = this.app.get(WindowService);
              const iht = rs.put(this.itemHostTemplate);
              const parent = rs.put(this);
              const ns = this.app.resolve(NavigationService);
              this.previousItem = this.selectedItem;
              const value = yield ns.openPage(`app://class/${iht.key}`, {
                "ref:comboBox": parent
              });
              this.selectedItem = value;
            } catch (e) {
              this.selectedItem = this.previousItem;
              if (e != "cancelled") {
                console.warn(e);
              } else {
                this.searchText = "";
              }
            } finally {
              yield Atom.delay(100);
              this.isPopupOpen = false;
            }
          });
        }
      };
      AutoCompleteBox.itemTemplate = XNode.prepare("itemTemplate", true, true);
      _export("default", AutoCompleteBox);
      __decorate([BindableProperty, __metadata("design:type", Object)], AutoCompleteBox.prototype, "selectedItem", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], AutoCompleteBox.prototype, "value", void 0);
    }
  };
});
//# sourceMappingURL=AutoCompleteBox.js.map