System.register(["@web-atoms/core/dist/web/styles/AtomStyle", "@web-atoms/core/dist/web/styles/StyleBuilder"], function (_export, _context) {
  "use strict";

  var AtomStyle, StyleBuilder, AutoCompleteBoxStyle;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistWebStylesAtomStyle) {
      AtomStyle = _webAtomsCoreDistWebStylesAtomStyle.AtomStyle;
    }, function (_webAtomsCoreDistWebStylesStyleBuilder) {
      StyleBuilder = _webAtomsCoreDistWebStylesStyleBuilder.default;
    }],
    execute: function () {
      _export("default", AutoCompleteBoxStyle = class AutoCompleteBoxStyle extends AtomStyle {
        get theme() {
          return this.styleSheet;
        }
        get root() {
          return {
            position: "relative",
            minWidth: "200px",
            minHeight: "25px",
            borderRadius: "3px",
            webkitBorderRadius: "3px",
            subclasses: {
              ".popup": this.popup,
              " .item": this.item,
              " .selected-item": this.selectedItem,
              " .item-template": this.itemTemplate,
              " > input[type=search]": Object.assign(Object.assign({}, StyleBuilder.newStyle.absolute(0, 0).toStyle()), {
                opacity: "0",
                zIndex: "100",
                borderRadius: "3px",
                webkitBorderRadius: "3px",
                subclasses: {
                  ":focus": {}
                }
              }),
              " > div": {
                zIndex: "1"
              },
              ".popup-open": {
                borderRadius: "3px",
                webkitBorderRadius: "3px",
                subclasses: {
                  " > input[type=search]": {
                    opacity: "1",
                    borderRadius: "3px",
                    webkitBorderRadius: "3px",
                    webkitAppearance: "none"
                  },
                  " > div": {
                    opacity: "0.3"
                  }
                }
              }
            }
          };
        }
        get popup() {
          return {
            overflow: "auto",
            width: "200px",
            height: "400px"
          };
        }
        get itemTemplate() {
          return Object.assign(Object.assign({}, StyleBuilder.newStyle.absolute(0, 0).toStyle()), this.item);
        }
        get item() {
          return {
            backgroundColor: this.theme.bgColor,
            color: this.theme.color,
            padding: "5px",
            borderRadius: "5px"
          };
        }
        get selectedItem() {
          return Object.assign(Object.assign({}, this.item), {
            backgroundColor: this.theme.selectedBgColor,
            color: this.theme.selectedColor
          });
        }
      });
    }
  };
});
//# sourceMappingURL=AutoCompleteBoxStyle.js.map