System.register(["tslib", "@web-atoms/core/dist/core/AtomBinder", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/core/XNode", "./AtomRepeater", "./Chip", "./styles/chips.global.css", "./styles/item-suggestion.global.css", "./elements/AtomPopover"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, __rest, AtomBinder, Bind, BindableProperty, CancelToken, XNode, AtomRepeater, MatchTrue, AtomPopover, AtomChips;
  function getChips(target) {
    let start = target;
    while (start) {
      const chips = start.atomControl;
      if (chips && chips instanceof AtomChips) {
        return chips;
      }
      start = start.parentElement;
    }
  }
  function askSuggestionPopup(host, opener, itemRenderer, suggestionFilter, cancelToken) {
    class Suggestions extends AtomPopover {
      init() {
        this.opener = opener;
        this.renderer = XNode.create("div", {
          "data-suggestion-popup": "suggestion-popup"
        }, XNode.create("div", {
          class: "items"
        }, XNode.create(AtomRepeater, {
          class: "presenter",
          selectedItem: Bind.source(opener, x => x.source.anchorItem),
          itemRenderer: itemRenderer,
          eventDeleteSuggestion: e => opener.element.dispatchEvent(e),
          visibilityFilter: suggestionFilter !== null && suggestionFilter !== void 0 ? suggestionFilter : MatchTrue,
          "event-item-click": e => {
            e.preventDefault();
            e.stopImmediatePropagation();
            e.stopPropagation();
            this.close(e.detail);
          },
          items: Bind.source(opener, x => x.source.suggestions)
        })));
      }
    }
    return Suggestions.show(host, {
      "anchor-top": "parent-bottom",
      "anchor-left": "parent-left",
      cancelToken
    });
  }
  function Suggestion(_a, ...nodes) {
    var {
        icon,
        label,
        header,
        deleteIcon
      } = _a,
      a = __rest(_a, ["icon", "label", "header", "deleteIcon"]);
    return XNode.create("div", Object.assign({
      "data-item-suggestion": "suggestion"
    }, a), icon && XNode.create("i", {
      class: "icon " + icon
    }), header && XNode.create("label", {
      class: "header",
      text: header,
      title: header
    }), label && XNode.create("label", {
      class: "label",
      text: label,
      title: label
    }), ...nodes, deleteIcon && XNode.create("i", {
      class: "delete " + deleteIcon,
      "data-click-event": "remove-suggestion"
    }));
  }
  _export({
    Suggestion: Suggestion,
    default: void 0
  });
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreAtomBinder) {
      AtomBinder = _webAtomsCoreDistCoreAtomBinder.AtomBinder;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      AtomRepeater = _AtomRepeater.default;
      MatchTrue = _AtomRepeater.MatchTrue;
    }, function (_Chip) {
      _export("Chip", _Chip.default);
    }, function (_stylesChipsGlobalCss) {}, function (_stylesItemSuggestionGlobalCss) {}, function (_elementsAtomPopover) {
      AtomPopover = _elementsAtomPopover.default;
    }],
    execute: function () {
      document.body.addEventListener("focusin", e => {
        const chips = getChips(e.target);
        chips === null || chips === void 0 ? void 0 : chips.setFocus(true);
      });
      document.body.addEventListener("focusout", e => {
        const chips = getChips(e.target);
        chips === null || chips === void 0 ? void 0 : chips.setFocus(false);
      });
      document.body.addEventListener("keydown", e => {
        const chips = getChips(e.target);
        chips === null || chips === void 0 ? void 0 : chips.onKey(e);
      });
      _export("default", AtomChips = class AtomChips extends AtomRepeater {
        get searchType() {
          return this.searchInput.type;
        }
        set searchType(v) {
          this.searchInput.type = v;
        }
        get enterKeyHint() {
          return this.searchInput.enterKeyHint;
        }
        set enterKeyHint(v) {
          this.searchInput.enterKeyHint = v;
        }
        onPropertyChanged(name) {
          var _a;
          super.onPropertyChanged(name);
          switch (name) {
            case "labelPath":
              this.itemRenderer = item => XNode.create("div", {
                text: this.labelPath(item)
              });
              break;
            case "prompt":
              this.updateClasses();
              break;
            case "focused":
              this.updatePopup();
              break;
            case "suggestions":
              (_a = this.suggestionsWatcher) === null || _a === void 0 ? void 0 : _a.dispose();
              this.suggestionsWatcher = undefined;
              const suggestions = this.suggestions;
              if (suggestions) {
                this.suggestionsWatcher = this.registerDisposable(suggestions.watch(() => {
                  this.updatePopup();
                }));
              }
              this.updatePopup();
              break;
          }
        }
        preCreate() {
          super.preCreate();
          this.preventDuplicates = true;
          this.softDeleteProperty = null;
          this.prompt = "Search";
          this.element.setAttribute("data-atom-chips", "atom-chips");
          this.element.setAttribute("data-mode", "search");
          this.suggestionFilter = MatchTrue;
          this.valuePath = item => {
            var _a;
            return (_a = item === null || item === void 0 ? void 0 : item.value) !== null && _a !== void 0 ? _a : item;
          };
          this.labelPath = item => {
            var _a;
            return (_a = item === null || item === void 0 ? void 0 : item.label) !== null && _a !== void 0 ? _a : item;
          };
          this.itemRenderer = item => XNode.create("div", {
            text: this.labelPath(item)
          });
          this.element.dataset.dropDown = "drop-down";
          this.render(XNode.create("div", null, XNode.create("div", {
            class: "presenter"
          }), XNode.create("input", {
            class: "search",
            placeholder: Bind.oneWay(() => this.prompt),
            value: Bind.twoWaysImmediate(() => this.search),
            autofocus: Bind.oneWay(() => this.autofocus),
            type: "search"
          }), XNode.create("div", {
            class: "footer"
          })));
          this.itemsPresenter = this.element.children[0];
          this.searchInput = this.element.children[1];
          this.footerPresenter = this.element.children[2];
          this.bindEvent(this.element, "removeChip", e => e.defaultPrevented || this.removeItem(e.detail));
          this.bindEvent(this.element, "undoRemoveChip", e => e.defaultPrevented || this.undoRemoveItem(e.detail));
          this.bindEvent(this.searchInput, "blur", () => {
            if (!this.onBlurItemToChip) {
              return;
            }
            setTimeout(() => {
              const search = this.search;
              if (search) {
                const item = this.onBlurItemToChip(search);
                if (item) {
                  this.items.add(item);
                  this.searchInput.value = "";
                  this.search = "";
                }
              }
            }, 200);
          });
        }
        setFocus(hasFocus) {
          if (hasFocus) {
            if (this.focusTimeout) {
              clearTimeout(this.focusTimeout);
              this.focusTimeout = void 0;
            }
            this.focused = true;
            return;
          }
          this.focusTimeout = setTimeout(() => {
            this.focusTimeout = void 0;
            this.focused = false;
          }, 1500);
        }
        updatePopup() {
          return __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c;
            const suggestions = this.suggestions;
            if (!this.focused) {
              (_a = this.popupCancelToken) === null || _a === void 0 ? void 0 : _a.cancel();
              this.popupCancelToken = null;
              return;
            }
            const detail = this.suggestions;
            const ce = new CustomEvent("suggestions-requested", {
              detail
            });
            this.element.dispatchEvent(ce);
            if (ce.defaultPrevented) {
              return;
            }
            const {
              promise
            } = ce;
            if (promise) {
              yield promise;
            }
            if (ce.detail !== this.suggestions) {
              this.suggestions = ce.detail;
            }
            if (!(suggestions === null || suggestions === void 0 ? void 0 : suggestions.length)) {
              (_b = this.popupCancelToken) === null || _b === void 0 ? void 0 : _b.cancel();
              this.popupCancelToken = null;
              return;
            }
            if (this.popupCancelToken) {
              return;
            }
            const cancelToken = this.popupCancelToken = new CancelToken();
            try {
              let selectedItem = yield askSuggestionPopup(this.element, this, (_c = this.suggestionRenderer) !== null && _c !== void 0 ? _c : this.itemRenderer, this.suggestionFilter, cancelToken);
              const itemToChip = this.itemToChip;
              if (itemToChip) {
                selectedItem = itemToChip(selectedItem, this.search);
              }
              this.addItem(selectedItem);
              this.search = "";
              this.popupCancelToken = null;
            } catch (e) {
              this.popupCancelToken = null;
              if (CancelToken.isCancelled(e)) {
                return;
              }
              console.warn(e);
            }
          });
        }
        addItem(selectedItem) {
          var _a;
          const ce = new CustomEvent("suggestionChosen", {
            detail: selectedItem,
            cancelable: true,
            bubbles: true
          });
          this.element.dispatchEvent(ce);
          if (!ce.defaultPrevented) {
            const item = ce.detail;
            const vp = (_a = this.valuePath) !== null && _a !== void 0 ? _a : x => x;
            const v = vp(item);
            for (const iterator of this.items) {
              if (v === vp(iterator)) {
                return;
              }
            }
            this.items.add(ce.detail);
          }
        }
        undoRemoveItem(item) {
          let {
            softDeleteProperty
          } = this;
          softDeleteProperty = typeof softDeleteProperty !== "string" ? "$deleted" : softDeleteProperty;
          item[softDeleteProperty] = false;
          AtomBinder.refreshValue(this.items, "length");
          this.refreshItem(item);
        }
        removeItem(item) {
          let {
            softDeleteProperty
          } = this;
          if (softDeleteProperty) {
            softDeleteProperty = typeof softDeleteProperty !== "string" ? "$deleted" : softDeleteProperty;
            item[softDeleteProperty] = true;
            AtomBinder.refreshValue(this.items, "length");
            this.refreshItem(item);
          } else {
            this.items.remove(item);
          }
        }
        onKey(e) {
          var _a, _b;
          const suggested = this.suggestions;
          const onKeyPressedItemToChip = this.onKeyPressedItemToChip;
          if (onKeyPressedItemToChip && this.search) {
            const item = onKeyPressedItemToChip(e.key, this.search);
            if (item) {
              this.addItem(item);
              this.searchInput.value = "";
              return;
            }
          }
          switch (e.key) {
            case "Enter":
              (_a = e.preventDefault) === null || _a === void 0 ? void 0 : _a.call(e);
              (_b = e.stopImmediatePropagation) === null || _b === void 0 ? void 0 : _b.call(e);
              setTimeout(() => {
                let anchorItem = this.anchorItem;
                const itemToChip = this.itemToChip;
                if (itemToChip) {
                  anchorItem = itemToChip(anchorItem, this.search);
                }
                if (!anchorItem) {
                  return;
                }
                this.addItem(anchorItem);
                this.anchorIndex = 0;
                this.anchorItem = null;
                this.search = "";
              }, 1);
              break;
            case "ArrowDown":
              if (suggested) {
                if (!this.anchorItem) {
                  this.anchorIndex = 0;
                } else {
                  if (this.anchorIndex < suggested.length - 1) {
                    this.anchorIndex++;
                  }
                }
                this.anchorItem = suggested[this.anchorIndex];
              }
              break;
            case "ArrowUp":
              if (suggested) {
                if (!this.anchorItem) {
                  return;
                }
                if (this.anchorIndex) {
                  this.anchorIndex--;
                }
                this.anchorItem = suggested[this.anchorIndex];
              }
              break;
          }
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Array)], AtomChips.prototype, "suggestions", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomChips.prototype, "search", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomChips.prototype, "prompt", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomChips.prototype, "suggestionPrompt", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], AtomChips.prototype, "autofocus", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomChips.prototype, "softDeleteProperty", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], AtomChips.prototype, "labelPath", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], AtomChips.prototype, "match", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], AtomChips.prototype, "suggestionRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], AtomChips.prototype, "suggestionFilter", void 0);
      __decorate([BindableProperty, __metadata("design:type", Boolean)], AtomChips.prototype, "focused", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], AtomChips.prototype, "onKeyPressedItemToChip", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], AtomChips.prototype, "onBlurItemToChip", void 0);
    }
  };
});
//# sourceMappingURL=AtomChips.js.map