import XNode from "@web-atoms/core/dist/core/XNode";
import DateTime from "@web-atoms/date-time/dist/DateTime";
import AtomRepeater from "./AtomRepeater";
import "./styles/calendar.global.css";
export declare const weekdays: {
    readonly short: any;
    readonly long: any;
};
export declare const months: {
    readonly short: any;
    readonly long: any;
    readonly items: any;
};
export interface ICalendarDate {
    label: string;
    type: string;
    value: DateTime;
    isToday: boolean;
    isOtherMonth: boolean;
    isWeekend: boolean;
    row: number;
    column: number;
    disabled: boolean;
}
export default class Calendar extends AtomRepeater {
    year: number;
    month: number;
    yearStart: number;
    yearEnd: number;
    set startDate(v: any);
    enableFunc: (item: ICalendarDate) => boolean;
    dateRenderer: (item: ICalendarDate) => XNode;
    get dates(): any[];
    get years(): any[];
    get value(): any;
    set value(v: any);
    /**
     * Date is modified by user, so do not auto select
     * start Date
     */
    private dateModified;
    onPropertyChanged(name: keyof Calendar): void;
    next(): void;
    prev(): void;
    protected preCreate(): void;
    protected dispatchItemEvent(eventName: any, item: any, recreate: any, originalTarget: any, nestedItem?: any): void;
}
//# sourceMappingURL=Calendar.d.ts.map