System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/WatchProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/date-time/dist/DateTime", "./AtomRepeater", "./Select", "./styles/calendar.global.css"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, Bind, BindableProperty, WatchProperty, XNode, DateTime, AtomRepeater, Select, Calendar, start, getWeekDays, getMonths, weekdays, months;
  function setValue(target, name, value) {
    Object.defineProperty(target, name, {
      value
    });
    return value;
  }
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreWatchProperty) {
      WatchProperty = _webAtomsCoreDistCoreWatchProperty.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsDateTimeDistDateTime) {
      DateTime = _webAtomsDateTimeDistDateTime.default;
    }, function (_AtomRepeater) {
      AtomRepeater = _AtomRepeater.default;
    }, function (_Select) {
      Select = _Select.default;
    }, function (_stylesCalendarGlobalCss) {}],
    execute: function () {
      start = DateTime.now;
      getWeekDays = (locale, type) => {
        const baseDate = new Date(Date.UTC(2017, 0, 2));
        const weekDays = [];
        for (let i = 0; i < 7; i++) {
          weekDays.push(baseDate.toLocaleDateString(locale, {
            weekday: type
          }));
          baseDate.setDate(baseDate.getDate() + 1);
        }
        return weekDays;
      };
      getMonths = (locale, type) => {
        const baseDate = new Date(Date.UTC(2017, 0, 2));
        const weekDays = [];
        for (let i = 0; i < 12; i++) {
          weekDays.push(baseDate.toLocaleDateString(locale, {
            month: type
          }));
          baseDate.setMonth(i + 1);
        }
        return weekDays;
      };
      _export("weekdays", weekdays = {
        get short() {
          return setValue(this, "short", getWeekDays(navigator.language, "short"));
        },
        get long() {
          return setValue(this, "long", getWeekDays(navigator.language, "long"));
        }
      });
      _export("months", months = {
        get short() {
          return setValue(this, "short", getMonths(navigator.language, "short"));
        },
        get long() {
          return setValue(this, "long", getMonths(navigator.language, "long"));
        },
        get items() {
          return setValue(this, "items", this.long.map((x, i) => ({
            label: x,
            value: i
          })));
        }
      });
      _export("default", Calendar = class Calendar extends AtomRepeater {
        constructor() {
          super(...arguments);
          this.dateModified = false;
        }
        set startDate(v) {
          if (this.dateModified) {
            return;
          }
          const year = v.getFullYear();
          const month = v.getMonth();
          if (this.year !== year) {
            this.year = year;
          }
          if (this.month !== month) {
            this.month = month;
          }
        }
        get dates() {
          const year = this.year;
          const tm = this.month;
          if (tm === undefined || year === undefined) {
            return [];
          }
          const month = Number(tm);
          const today = DateTime.today;
          let startDate = new DateTime(year, month, 1);
          while (startDate.dayOfWeek !== 1) {
            startDate = startDate.add(-1);
          }
          const a = [];
          const y = startDate.year;
          const m = startDate.month;
          const ef = this.enableFunc;
          for (let index = 0; index < 42; index++) {
            const cd = startDate.add(index);
            const item = {
              label: cd.day + "",
              row: Math.floor(index / 7),
              column: index % 7,
              type: null,
              value: cd,
              isToday: cd.equals(today),
              isOtherMonth: month !== cd.month,
              isWeekend: cd.dayOfWeek === 0 || cd.dayOfWeek === 6,
              disabled: false
            };
            if (ef) {
              item.disabled = !ef(item);
            }
            a.push(item);
          }
          return a;
        }
        get years() {
          const years = [];
          const s = start.year + this.yearStart;
          const e = start.year + this.yearEnd + 1;
          for (let index = s; index < e; index++) {
            years.push({
              label: index.toString(),
              value: index
            });
          }
          return years;
        }
        get value() {
          return super.value;
        }
        set value(v) {
          if (v instanceof Date) {
            this.startDate = v;
          }
          super.value = v;
        }
        onPropertyChanged(name) {
          super.onPropertyChanged(name);
          switch (name) {
            case "enableFunc":
            case "dateRenderer":
              this.updateItems();
              break;
          }
        }
        next() {
          if (this.month === 11) {
            this.year++;
            this.month = 0;
            return;
          }
          this.month++;
        }
        prev() {
          if (this.month === 0) {
            this.year--;
            this.month = 11;
            return;
          }
          this.month--;
        }
        preCreate() {
          super.preCreate();
          const now = new Date();
          this.selectedItems = [];
          this.valuePath = i => i === null || i === void 0 ? void 0 : i.value;
          this.yearStart = -10;
          this.yearEnd = 10;
          this.year = now.getFullYear();
          this.month = now.getMonth();
          this.comparer = (left, right) => {
            var _a, _b;
            return left && right && ((_a = DateTime.from(left).date) === null || _a === void 0 ? void 0 : _a.msSinceEpoch) === ((_b = DateTime.from(right).date) === null || _b === void 0 ? void 0 : _b.msSinceEpoch);
          };
          this.bindEvent(this.element, "change", () => this.dateModified = true, null, {
            capture: true
          });
          this.bindEvent(this.element, "itemSelect", e => e.detail.disabled ? e.preventDefault() : null);
          this.render(XNode.create("div", {
            "data-calendar": "calendar",
            items: Bind.oneWay(() => this.dates)
          }, XNode.create("i", {
            "data-element": "previous",
            "event-click": () => this.prev(),
            class: "fa-solid fa-circle-chevron-left",
            title: "Previous Month"
          }), XNode.create(Select, {
            "data-element": "month",
            items: months.items,
            value: Bind.twoWays(() => this.month)
          }), XNode.create(Select, {
            "data-element": "year",
            items: Bind.oneWay(() => this.years),
            value: Bind.twoWays(() => this.year)
          }), XNode.create("i", {
            "data-element": "next",
            "event-click": () => this.next(),
            class: "fa-solid fa-circle-chevron-right",
            title: "Next Month"
          }), XNode.create("div", {
            class: "week"
          }), XNode.create("div", {
            "data-click-event": "item-select",
            class: "dates"
          })));
          this.itemsPresenter = this.element.lastElementChild;
          const week = this.element.lastElementChild.previousElementSibling;
          let w = 1;
          for (const iterator of weekdays.short) {
            const text = document.createElement("span");
            text.textContent = iterator;
            week.appendChild(text);
            text.style.gridColumnStart = `${w++}`;
          }
          this.dateRenderer = item => XNode.create("div", {
            text: item.label
          });
          this.itemRenderer = item => {
            var _a;
            const d = this.dateRenderer(item);
            const a = (_a = d.attributes) !== null && _a !== void 0 ? _a : d.attributes = {};
            if (item.isToday) {
              a["data-is-today"] = item.isToday;
            }
            if (item.isOtherMonth) {
              a["data-is-other-month"] = item.isOtherMonth;
            }
            if (item.isWeekend) {
              a["data-is-weekend"] = item.isWeekend;
            }
            if (item.disabled) {
              a["data-disabled"] = item.disabled;
            }
            return d;
          };
        }
        dispatchItemEvent(eventName, item, recreate, originalTarget, nestedItem) {
          this.dateModified = true;
          super.dispatchItemEvent(eventName, item, recreate, originalTarget, nestedItem);
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Number)], Calendar.prototype, "year", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], Calendar.prototype, "month", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], Calendar.prototype, "yearStart", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], Calendar.prototype, "yearEnd", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], Calendar.prototype, "enableFunc", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], Calendar.prototype, "dateRenderer", void 0);
      __decorate([WatchProperty, __metadata("design:type", Object), __metadata("design:paramtypes", [])], Calendar.prototype, "dates", null);
      __decorate([WatchProperty, __metadata("design:type", Object), __metadata("design:paramtypes", [])], Calendar.prototype, "years", null);
    }
  };
});
//# sourceMappingURL=Calendar.js.map