System.register(["tslib", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "./AtomRepeater", "./styles/check-box-list.global.css"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, BindableProperty, XNode, AtomRepeater, SameObjectValue, CheckBoxList;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      AtomRepeater = _AtomRepeater.default;
      SameObjectValue = _AtomRepeater.SameObjectValue;
    }, function (_stylesCheckBoxListGlobalCss) {}],
    execute: function () {
      _export("default", CheckBoxList = class CheckBoxList extends AtomRepeater {
        preCreate() {
          super.preCreate();
          this.element.dataset.checkboxList = "checkbox-list";
          this.bindEvent(this.element, "itemClick", e => {
            var _a;
            const s = this.selectedItems;
            if (!s) {
              return;
            }
            const item = e.detail;
            const vp = (_a = this.valuePath) !== null && _a !== void 0 ? _a : SameObjectValue;
            const value = vp(item);
            let existing = s.find(i => vp(i) === value);
            if (!existing) {
              s.add(item);
              this.element.dispatchEvent(new CustomEvent("itemSelect", {
                detail: item,
                bubbles: false
              }));
              if (this.softDeleteProperty) {
                item[this.softDeleteProperty] = false;
              }
              this.refreshItem(item);
            } else {
              if (this.softDeleteProperty) {
                const existingItem = this.items.find(i => vp(i) === value);
                if (existing[this.softDeleteProperty] === true) {
                  existing[this.softDeleteProperty] = false;
                  if (existingItem && existingItem !== existing) {
                    existingItem[this.softDeleteProperty] = false;
                    this.element.dispatchEvent(new CustomEvent("itemSelect", {
                      detail: item,
                      bubbles: false
                    }));
                    this.refreshItem(existingItem);
                  }
                  this.element.dispatchEvent(new CustomEvent("itemSelect", {
                    detail: item,
                    bubbles: false
                  }));
                } else {
                  existing[this.softDeleteProperty] = true;
                  if (existingItem && existingItem !== existing) {
                    existingItem[this.softDeleteProperty] = true;
                    this.element.dispatchEvent(new CustomEvent("itemDeselect", {
                      detail: item,
                      bubbles: false
                    }));
                    this.refreshItem(existingItem);
                  }
                  this.element.dispatchEvent(new CustomEvent("itemDeselect", {
                    detail: existing,
                    bubbles: false
                  }));
                }
                this.refreshItem(existing);
              } else {
                this.element.dispatchEvent(new CustomEvent("itemDeselect", {
                  detail: existing,
                  bubbles: false
                }));
                s.remove(existing);
              }
            }
          });
          this.itemRenderer = item => {
            if (this.softDeleteProperty) {
              return XNode.create("div", {
                "data-deleted": !!item[this.softDeleteProperty],
                "data-item-type": "checkbox"
              }, XNode.create("i", {
                class: "far fa-square"
              }), XNode.create("i", {
                class: "fas fa-check-square"
              }), XNode.create("span", {
                text: item.label
              }));
            }
            return XNode.create("div", {
              "data-deleted": "none",
              "data-item-type": "checkbox"
            }, XNode.create("i", {
              class: "far fa-square"
            }), XNode.create("i", {
              class: "fas fa-check-square"
            }), XNode.create("span", {
              text: item.label
            }));
          };
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Object)], CheckBoxList.prototype, "labelPath", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], CheckBoxList.prototype, "softDeleteProperty", void 0);
    }
  };
});
//# sourceMappingURL=CheckBoxList.js.map