System.register(["tslib", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "./AtomRepeater"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, BindableProperty, XNode, AtomRepeater, ComboBox;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      AtomRepeater = _AtomRepeater.default;
    }],
    execute: function () {
      _export("default", ComboBox = class ComboBox extends AtomRepeater {
        constructor(app, e = document.createElement("select")) {
          super(app, e);
          this.isChanging = false;
          this.selectedItems = [];
        }
        updateItems(container) {
          var _a, _b;
          if (this.isChanging) {
            return;
          }
          super.updateItems(container);
          const selectedItems = this.selectedItems;
          if (!selectedItems) {
            return;
          }
          if (selectedItems.length === 0) {
            return;
          }
          this.isChanging = true;
          const value = this.value;
          const valuePath = (_a = this.valuePath) !== null && _a !== void 0 ? _a : item => item;
          this.element.selectedIndex = (_b = this.items) === null || _b === void 0 ? void 0 : _b.findIndex(v => valuePath(v) == value);
          this.isChanging = false;
        }
        updateClasses() {
          if (this.isChanging) {
            return;
          }
          super.updateClasses();
          this.updateItems();
        }
        preCreate() {
          super.preCreate();
          this.labelPath = item => {
            var _a;
            return (_a = item === null || item === void 0 ? void 0 : item.label) !== null && _a !== void 0 ? _a : item.toString();
          };
          this.valuePath = item => {
            var _a;
            return (_a = item === null || item === void 0 ? void 0 : item.value) !== null && _a !== void 0 ? _a : item.toString();
          };
          this.itemRenderer = item => XNode.create("option", null, this.labelPath(item));
          this.bindEvent(this.element, "change", () => this.changeSelection());
        }
        changeSelection() {
          if (this.isChanging) {
            return;
          }
          this.isChanging = true;
          const index = this.element.selectedIndex;
          if (index !== -1) {
            const si = this.selectedItems;
            if (si) {
              si.set(0, this.items[index]);
            }
          }
          this.isChanging = false;
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Object)], ComboBox.prototype, "labelPath", void 0);
    }
  };
});
//# sourceMappingURL=ComboBox.js.map