System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/date-time/dist/DateTime", "./Calendar", "./TimeEditor", "@web-atoms/date-time/dist/TimeSpan", "./styles/date-field.global.css", "./elements/AtomPopover"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, Bind, BindableProperty, XNode, AtomControl, DateTime, Calendar, TimeEditor, TimeSpan, AtomPopover, DateField;
  function hours() {
    return [{
      label: "01",
      value: 1
    }, {
      label: "02",
      value: 2
    }, {
      label: "03",
      value: 3
    }, {
      label: "04",
      value: 4
    }, {
      label: "05",
      value: 5
    }, {
      label: "06",
      value: 6
    }, {
      label: "07",
      value: 7
    }, {
      label: "08",
      value: 8
    }, {
      label: "09",
      value: 9
    }, {
      label: "10",
      value: 10
    }, {
      label: "11",
      value: 11
    }, {
      label: "12",
      value: 12
    }];
  }
  function minutes() {
    const items = [];
    for (let index = 0; index < 10; index++) {
      items.push({
        label: "0" + index,
        value: index
      });
    }
    for (let index = 10; index < 60; index++) {
      items.push({
        label: index.toString(),
        value: index
      });
    }
    return items;
  }
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsDateTimeDistDateTime) {
      DateTime = _webAtomsDateTimeDistDateTime.default;
    }, function (_Calendar) {
      Calendar = _Calendar.default;
    }, function (_TimeEditor) {
      TimeEditor = _TimeEditor.default;
    }, function (_webAtomsDateTimeDistTimeSpan) {
      TimeSpan = _webAtomsDateTimeDistTimeSpan.default;
    }, function (_stylesDateFieldGlobalCss) {}, function (_elementsAtomPopover) {
      AtomPopover = _elementsAtomPopover.default;
    }],
    execute: function () {
      _export("default", DateField = class DateField extends AtomControl {
        constructor(app, e = document.createElement("button")) {
          super(app, e);
        }
        preCreate() {
          this.prompt = "Select";
          this.enableTime = false;
          this.value = null;
          this.format = (d, showTime) => showTime ? d === null || d === void 0 ? void 0 : d.toLocaleString(navigator.language, {
            month: "short",
            year: "numeric",
            day: "numeric",
            weekday: "short",
            hour12: true,
            hour: "numeric",
            minute: "2-digit"
          }) : d === null || d === void 0 ? void 0 : d.toLocaleDateString(navigator.language, {
            month: "short",
            year: "numeric",
            day: "numeric",
            weekday: "short"
          });
          const owner = this;
          class CalendarPopup extends AtomPopover {
            init() {
              var _a;
              this.owner = owner;
              this.type = "AM";
              const now = DateTime.from((_a = owner.value) !== null && _a !== void 0 ? _a : DateTime.today.addHours(owner.hour || 0).addMinutes(owner.minute || 0));
              this.time = new TimeSpan(0, now.hour, now.minute);
              const yearStart = typeof this.owner.yearStart === "number" ? this.owner.yearStart : -10;
              const yearEnd = typeof this.owner.yearEnd === "number" ? this.owner.yearEnd : 10;
              const year = typeof this.owner.year === "number" ? this.owner.year : now.year;
              this.renderer = XNode.create("div", {
                class: "calendar-popup"
              }, XNode.create(Calendar, {
                yearStart: yearStart,
                yearEnd: yearEnd,
                year: year,
                "event-item-select": Bind.event((s, e) => {
                  if (e.detail.disabled) {
                    return;
                  }
                  this.save(e.detail.value);
                }),
                enableFunc: Bind.oneTime(() => this.owner.enableFunc),
                value: Bind.oneWay(() => this.owner.value)
              }), this.owner.enableTime && XNode.create(TimeEditor, {
                time: Bind.twoWays(() => this.time)
              }), XNode.create("button", {
                class: "clear",
                text: "Clear",
                "event-click": e => {
                  e.preventDefault();
                  e.stopImmediatePropagation();
                  e.stopPropagation();
                  this.save();
                }
              }), XNode.create("button", {
                class: "today",
                text: "Today",
                "event-click": e => {
                  e.preventDefault();
                  e.stopImmediatePropagation();
                  e.stopPropagation();
                  this.save(DateTime.today.asJSDate);
                }
              }));
            }
            save(d) {
              if (!d) {
                this.owner.value = d;
                this.close(d);
                return;
              }
              let date = DateTime.from(d);
              if (this.owner.enableTime) {
                date = date.add(this.time);
              }
              this.owner.value = date.asJSDate;
              this.close(date);
            }
          }
          this.render(XNode.create("div", {
            "data-layout": "flex",
            "data-date-field": "date-field",
            text: Bind.oneWay(() => {
              var _a;
              return ((_a = this.format) === null || _a === void 0 ? void 0 : _a.call(this, this.value, this.enableTime)) || this.prompt;
            }),
            "event-click": () => CalendarPopup.show(this, {
              "anchor-left": "parent-left"
            })
          }));
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Date)], DateField.prototype, "value", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DateField.prototype, "enableFunc", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DateField.prototype, "format", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], DateField.prototype, "yearStart", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], DateField.prototype, "yearEnd", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], DateField.prototype, "year", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], DateField.prototype, "hour", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], DateField.prototype, "minute", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], DateField.prototype, "prompt", void 0);
    }
  };
});
//# sourceMappingURL=DateField.js.map