System.register(["tslib", "@web-atoms/core/dist/core/StringHelper", "@web-atoms/core/dist/web/controls/AtomControl", "./FilesDragDrop.global.css"], function (_export, _context) {
  "use strict";

  var __asyncValues, __awaiter, StringHelper, AtomControl, supportsFileSystemAccessAPI, supportsWebkitGetAsEntry, dragEnter, dragOver, dragLeave, eventDrop, FilesDragDrop;
  return {
    setters: [function (_tslib) {
      __asyncValues = _tslib.__asyncValues;
      __awaiter = _tslib.__awaiter;
    }, function (_webAtomsCoreDistCoreStringHelper) {
      StringHelper = _webAtomsCoreDistCoreStringHelper.StringHelper;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_FilesDragDropGlobalCss) {}],
    execute: function () {
      supportsFileSystemAccessAPI = "getAsFileSystemHandle" in DataTransferItem.prototype;
      supportsWebkitGetAsEntry = "webkitGetAsEntry" in DataTransferItem.prototype;
      dragEnter = e => {
        if (!e.dataTransfer) {
          return;
        }
        e.currentTarget.setAttribute("data-drop-enabled", "1");
      };
      dragOver = e => {
        if (!e.dataTransfer) {
          return;
        }
        e.preventDefault();
      };
      dragLeave = e => {
        if (!e.dataTransfer) {
          return;
        }
        e.currentTarget.removeAttribute("data-drop-enabled");
      };
      eventDrop = e => {
        if (!e.dataTransfer) {
          return;
        }
        e.preventDefault();
        const currentTarget = e.currentTarget;
        currentTarget.removeAttribute("data-drop-enabled");
        const uploadEvent = StringHelper.fromHyphenToCamel(currentTarget.getAttribute("data-upload-event"));
        const uploadRequested = StringHelper.fromHyphenToCamel(currentTarget.getAttribute("data-upload-requested"));
        const extra = currentTarget.getAttribute("data-extra");
        const convert = currentTarget.getAttribute("data-convert") === "true";
        const maxSize = parseInt(currentTarget.getAttribute("data-max-size") || "0", 10);
        const fileHandlesPromises = [...e.dataTransfer.items].filter(item => item.kind === "file").map(item => supportsFileSystemAccessAPI ? item.getAsFileSystemHandle() : supportsWebkitGetAsEntry ? item.webkitGetAsEntry() : item.getAsFile());
        const files = [];
        const getFiles = (dir_1, ...args_1) => __awaiter(void 0, [dir_1, ...args_1], void 0, function* (dir, parent = dir.name) {
          var _a, e_1, _b, _c;
          const all = [];
          try {
            for (var _d = true, _e = __asyncValues(dir.entries()), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
              _c = _f.value;
              _d = false;
              const [name, handle] = _c;
              const path = `${parent}/${handle.name}`;
              if (handle.kind === "directory" || handle.isDirectory) {
                all.push(...(yield getFiles(handle, path)));
                continue;
              }
              const file = yield handle.getFile();
              Object.defineProperty(file, "webkitRelativePath", {
                value: path
              });
              all.push(file);
            }
          } catch (e_1_1) {
            e_1 = {
              error: e_1_1
            };
          } finally {
            try {
              if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
            } finally {
              if (e_1) throw e_1.error;
            }
          }
          return all;
        });
        const control = AtomControl.from(e.currentTarget);
        control.app.runAsync(() => __awaiter(void 0, void 0, void 0, function* () {
          var _a, e_2, _b, _c;
          try {
            for (var _d = true, fileHandlesPromises_1 = __asyncValues(fileHandlesPromises), fileHandlesPromises_1_1; fileHandlesPromises_1_1 = yield fileHandlesPromises_1.next(), _a = fileHandlesPromises_1_1.done, !_a; _d = true) {
              _c = fileHandlesPromises_1_1.value;
              _d = false;
              const handle = _c;
              if (handle.kind === "directory" || handle.isDirectory) {
                files.push(...(yield getFiles(handle)));
              } else {
                files.push(yield handle.getFile());
              }
            }
          } catch (e_2_1) {
            e_2 = {
              error: e_2_1
            };
          } finally {
            try {
              if (!_d && !_a && (_b = fileHandlesPromises_1.return)) yield _b.call(fileHandlesPromises_1);
            } finally {
              if (e_2) throw e_2.error;
            }
          }
          const detail = {
            files,
            extra,
            convert,
            maxSize,
            uploadEvent
          };
          currentTarget.dispatchEvent(new CustomEvent(uploadRequested, {
            detail,
            bubbles: true,
            cancelable: true
          }));
        }));
      };
      _export("FilesDragDrop", FilesDragDrop = ({
        uploadEvent = "files-available",
        uploadRequested = "upload-requested",
        convert = false,
        maxSize = 50 * 1024 * 1024,
        extra = ""
      }) => ({
        "data-extra": extra,
        "data-drag-drop": "1",
        "data-convert": convert,
        "data-upload-event": uploadEvent,
        "data-upload-requested": uploadRequested,
        "data-max-size": maxSize,
        "event-dragenter": dragEnter,
        "event-dragleave": dragLeave,
        "event-dragover": dragOver,
        "event-drop": eventDrop
      }));
    }
  };
});
//# sourceMappingURL=FilesDragDrop.js.map