import XNode from "@web-atoms/core/dist/core/XNode";
import "../styles/form.global.css";
export interface IForm {
    /**
     * The event that will be dispatched, default is `submitForm`
     */
    "data-submit-event"?: string;
    /**
     * Validation will be displayed if set to true, default is false.
     * It will be set to true if button with type=submit or data-type=submit will be clicked.
     */
    "data-show-validation"?: "true" | "false";
    /**
     * Default error message to be displayed if any field contains error.
     */
    "data-error-message"?: string;
    /**
     * Please change your form style to catch event-submit-form
     */
    eventSubmit?: never;
    /**
     * Please change your form style to catch event-submit-form
     */
    submitCommand?: never;
    [key: string]: any;
}
export default function Form({ "data-submit-event": submitEvent, "data-show-validation": showValidation, "data-error-message": errorMessage, ...a }: IForm, ...nodes: XNode[]): any;
type Func = (...p: any[]) => any;
export interface IValidator {
    value: Func;
    message?: (value: string, label: string) => string;
    isValid?: (value: string, element: HTMLElement) => boolean;
}
export declare const BindError: ({ value, message, isValid, }: IValidator) => any;
export declare const BindEmailError: ({ value, message, isValid, }: IValidator) => any;
export {};
//# sourceMappingURL=Form.d.ts.map