System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/FormattedString", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/services/NavigationService", "@web-atoms/core/dist/web/services/PopupService", "./styles/form-field.global.css"], function (_export, _context) {
  "use strict";

  var __rest, Bind, FormattedString, XNode, NavigationService, PopupWindow;
  function FormField(_a, node) {
    var _b, _c, _d, _e, _f;
    var {
        label,
        required,
        error,
        helpIcon = "fas fa-question-circle",
        help,
        helpEventClick,
        helpTitle,
        border = false
      } = _a,
      others = __rest(_a, ["label", "required", "error", "helpIcon", "help", "helpEventClick", "helpTitle", "border"]);
    if (node) {
      const na = (_b = node.attributes) !== null && _b !== void 0 ? _b : node.attributes = {};
      na["data-element"] = "content";
    }
    if (!helpEventClick && help) {
      helpEventClick = Bind.event((s, e) => {
        const app = s.app;
        if (typeof help === "string" || help instanceof FormattedString) {
          const ns = app.resolve(NavigationService);
          ns.notify(help);
          return;
        }
        class HelpPopup extends PopupWindow {
          create() {
            this.render(XNode.create("div", {
              "data-form-field-help": "help-window"
            }, help));
          }
        }
        HelpPopup.showWindow({
          title: helpTitle !== null && helpTitle !== void 0 ? helpTitle : "Help",
          modal: true
        });
      });
    }
    let labelIsNode = false;
    if (label) {
      if (label instanceof XNode) {
        const la = (_c = label.attributes) !== null && _c !== void 0 ? _c : label.attributes = {};
        la["data-element"] = "label";
        labelIsNode = true;
      } else {
        if (node) {
          if (!(((_d = node.attributes) === null || _d === void 0 ? void 0 : _d.ariaLabel) || ((_e = node.attributes) === null || _e === void 0 ? void 0 : _e["aria-label"]))) {
            ((_f = node.attributes) !== null && _f !== void 0 ? _f : node.attributes = {})["aria-label"] = label;
          }
        }
      }
    }
    return XNode.create("div", Object.assign({
      "data-wa-form-field": "wa-form-field",
      "data-border": border
    }, others), label && (labelIsNode ? label : XNode.create("label", {
      "data-element": "label",
      text: label
    })), required && XNode.create("span", {
      "data-required": "required",
      class: required,
      text: "*"
    }), border && XNode.create("i", {
      "data-border": "border"
    }), node, help && XNode.create("i", {
      "data-help": "help",
      class: helpIcon,
      title: helpTitle,
      eventClick: helpEventClick
    }), XNode.create("div", {
      class: "field-error",
      text: error
    }));
  }
  function HorizontalFormField(_a, node) {
    var _b, _c, _d, _e;
    var {
        label,
        required,
        error,
        helpIcon = "fas fa-question-circle",
        help,
        helpEventClick,
        helpTitle,
        border = false
      } = _a,
      others = __rest(_a, ["label", "required", "error", "helpIcon", "help", "helpEventClick", "helpTitle", "border"]);
    if (node) {
      const na = (_b = node.attributes) !== null && _b !== void 0 ? _b : node.attributes = {};
      na["data-content"] = "content";
    }
    if (!helpEventClick && help) {
      helpEventClick = Bind.event((s, e) => {
        const app = s.app;
        if (typeof help === "string" || help instanceof FormattedString) {
          const ns = app.resolve(NavigationService);
          ns.notify(help);
          return;
        }
        class HelpPopup extends PopupWindow {
          create() {
            this.render(XNode.create("div", {
              "data-form-field-help": "help-window"
            }, help));
          }
        }
        HelpPopup.showWindow({
          title: helpTitle !== null && helpTitle !== void 0 ? helpTitle : "Help"
        });
      });
    }
    if (node) {
      if (!(((_c = node.attributes) === null || _c === void 0 ? void 0 : _c.ariaLabel) || ((_d = node.attributes) === null || _d === void 0 ? void 0 : _d["aria-label"]))) {
        ((_e = node.attributes) !== null && _e !== void 0 ? _e : node.attributes = {})["aria-label"] = label;
      }
    }
    return XNode.create("div", Object.assign({
      "data-wa-form-field": "wa-form-field",
      "data-layout": "horizontal",
      "data-border": border
    }, others), label && XNode.create("label", {
      class: "label",
      text: label
    }), required && XNode.create("span", {
      "data-required": "required",
      class: required,
      text: "*"
    }), border && XNode.create("i", {
      "data-border": "border"
    }), node, help && XNode.create("i", {
      "data-help": "help",
      class: helpIcon,
      title: helpTitle,
      eventClick: helpEventClick
    }), XNode.create("div", {
      class: "field-error",
      text: error
    }));
  }
  _export({
    default: FormField,
    HorizontalFormField: HorizontalFormField
  });
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreFormattedString) {
      FormattedString = _webAtomsCoreDistCoreFormattedString.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistServicesNavigationService) {
      NavigationService = _webAtomsCoreDistServicesNavigationService.NavigationService;
    }, function (_webAtomsCoreDistWebServicesPopupService) {
      PopupWindow = _webAtomsCoreDistWebServicesPopupService.PopupWindow;
    }, function (_stylesFormFieldGlobalCss) {}],
    execute: function () {
      document.body.addEventListener("click", e => {
        var _a;
        let label = e.target;
        while (label && label.tagName !== "LABEL") {
          if (label.getAttribute("data-element") === "label") {
            break;
          }
          label = label.parentElement;
          if (label === document.body) {
            return;
          }
        }
        if (!label) {
          return;
        }
        const formField = label.parentElement;
        if (!formField.hasAttribute("data-wa-form-field")) {
          return;
        }
        const selectable = formField.querySelector("select,input,textarea");
        (_a = selectable === null || selectable === void 0 ? void 0 : selectable.focus) === null || _a === void 0 ? void 0 : _a.call(selectable);
      });
      document.addEventListener("focusin", e => {
        let target = e.target;
        while (target) {
          if (target.getAttribute("data-wa-form-field") === "wa-form-field") {
            target.setAttribute("data-focused", "true");
            break;
          }
          target = target.parentElement;
        }
      });
      document.addEventListener("focusout", e => {
        let target = e.target;
        while (target) {
          if (target.getAttribute("data-wa-form-field") === "wa-form-field") {
            target.removeAttribute("data-focused");
            break;
          }
          target = target.parentElement;
        }
      });
    }
  };
});
//# sourceMappingURL=FormField.js.map