import XNode from "@web-atoms/core/dist/core/XNode";
import { AtomControl } from "@web-atoms/core/dist/web/controls/AtomControl";
import { IPopupOptions } from "@web-atoms/core/dist/web/services/PopupService";
import IElement from "./IElement";
import "./styles/inline-popup.global.css";
export interface IInlinePopupOptions extends IPopupOptions {
    defaultOnClick?: "close" | "cancel" | null | undefined;
}
export default class InlinePopup extends AtomControl {
    static show<T = void>(target: HTMLElement | AtomControl, node: XNode, options?: IInlinePopupOptions): Promise<T>;
    static showControl<T>(target: HTMLElement | AtomControl, options?: IPopupOptions): Promise<T>;
    close: (r?: any) => void;
    cancel: (r?: any) => void;
    protected dispatchClickEvent(e: MouseEvent, data: any): void;
}
export interface IInlinePopupButtonOptions extends IElement {
    text?: any;
    label?: any;
    icon?: any;
    hasBorder?: boolean;
    nodes?: XNode[];
    defaultOnClick?: "close" | "cancel";
    anchorRight?: boolean;
    alignment?: IPopupOptions["alignment"];
    popup?: PopupFactory;
}
export type PopupFactory = (data: any) => XNode;
export declare function InlinePopupButton({ text, label, icon, hasBorder, nodes, defaultOnClick, anchorRight, alignment, popup, ...a }: IInlinePopupButtonOptions, ...popupNodes: XNode[]): any;
//# sourceMappingURL=InlinePopup.d.ts.map