System.register(["tslib", "@web-atoms/core/dist/core/AtomDisposableList", "@web-atoms/core/dist/core/sleep", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "./styles/inline-popup.global.css", "@web-atoms/core/dist/core/StringHelper"], function (_export, _context) {
  "use strict";

  var __awaiter, __rest, AtomDisposableList, sleep, XNode, AtomControl, ElementValueSetters, StringHelper, InlinePopup;
  function closeHandler(opener, container, close) {
    let handler = null;
    const body = document.body;
    handler = e => {
      var _a;
      let start = e.target;
      if (e.defaultPrevented) {
        return;
      }
      while (start) {
        if (start === body) {
          break;
        }
        if (start === opener) {
          return;
        }
        if (start === container) {
          return;
        }
        start = start.parentElement;
      }
      close();
      e.preventDefault();
      (_a = e.stopImmediatePropagation) === null || _a === void 0 ? void 0 : _a.call(e);
    };
    document.body.addEventListener("click", handler, true);
    let ce = container;
    const containNoneList = [];
    while (ce) {
      const isNotNone = window.getComputedStyle(ce).contain !== "none";
      if (isNotNone) {
        ce.setAttribute("data-force-contain", "none");
        containNoneList.push(ce);
      }
      ce = ce.parentElement;
    }
    return () => {
      document.body.removeEventListener("click", handler, true);
      for (const iterator of containNoneList) {
        iterator.removeAttribute("data-force-contain");
      }
    };
  }
  function InlinePopupButton(_a, ...popupNodes) {
    var {
        text,
        label,
        icon,
        hasBorder = false,
        nodes = [],
        defaultOnClick = "close",
        anchorRight = false,
        alignment,
        popup
      } = _a,
      a = __rest(_a, ["text", "label", "icon", "hasBorder", "nodes", "defaultOnClick", "anchorRight", "alignment", "popup"]);
    alignment || (alignment = anchorRight ? "bottomRight" : "bottomLeft");
    console.warn(`Deprecated, use AtomPopover instead`);
    if (!a["data-layout"]) {
      if (icon && text) {
        a["data-layout"] = "icon-button";
      } else {
        a["data-layout"] = "button";
      }
    }
    if (popup) {
      return XNode.create("button", Object.assign({
        "data-popup-class": popup,
        "data-has-border": !!hasBorder,
        "data-inline-popup-button": "inline-popup-button",
        "data-default-on-click": defaultOnClick,
        "data-alignment": alignment
      }, a), icon && XNode.create("i", {
        class: icon
      }), text && XNode.create("span", {
        text: text
      }), label && XNode.create("label", {
        text: text
      }), ...nodes);
    }
    let isOpen = false;
    const done = () => isOpen = false;
    const click = e => __awaiter(this, void 0, void 0, function* () {
      if (isOpen || e.defaultPrevented) {
        return;
      }
      const currentTarget = e.currentTarget;
      currentTarget.setAttribute("data-popup-open", "true");
      const popupNode = popupNodes.length > 1 ? XNode.create("div", null, ...popupNodes) : popupNodes[0];
      try {
        isOpen = true;
        yield InlinePopup.show(e.currentTarget, popupNode, {
          defaultOnClick,
          alignment
        });
      } finally {
        done();
        currentTarget.removeAttribute("data-popup-open");
      }
    });
    return XNode.create("button", Object.assign({
      "event-click": click,
      "data-has-border": !!hasBorder,
      "data-alignment": alignment,
      "data-inline-popup-button": "inline-popup-button"
    }, a), icon && XNode.create("i", {
      class: icon
    }), text && XNode.create("span", {
      text: text
    }), label && XNode.create("label", {
      text: text
    }), ...nodes);
  }
  _export({
    default: void 0,
    InlinePopupButton: InlinePopupButton
  });
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreAtomDisposableList) {
      AtomDisposableList = _webAtomsCoreDistCoreAtomDisposableList.AtomDisposableList;
    }, function (_webAtomsCoreDistCoreSleep) {
      sleep = _webAtomsCoreDistCoreSleep.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
      ElementValueSetters = _webAtomsCoreDistWebControlsAtomControl.ElementValueSetters;
    }, function (_stylesInlinePopupGlobalCss) {}, function (_webAtomsCoreDistCoreStringHelper) {
      StringHelper = _webAtomsCoreDistCoreStringHelper.StringHelper;
    }],
    execute: function () {
      _export("default", InlinePopup = class InlinePopup extends AtomControl {
        static show(target_1, node_1) {
          return __awaiter(this, arguments, void 0, function* (target, node, options = {}) {
            var _a;
            const targetElement = (_a = target.element) !== null && _a !== void 0 ? _a : target;
            const control = target.element ? target : AtomControl.from(target);
            const targetStyle = window.getComputedStyle(targetElement);
            if (!/fixed|absolute|relative/i.test(targetStyle.position)) {
              targetElement.style.position = "relative";
            }
            yield sleep(10);
            const container = document.createElement("div");
            container.setAttribute("data-inline-popup", "inline-popup");
            const alignment = StringHelper.fromHyphenToCamel(options.alignment || "none");
            switch (alignment) {
              case "bottomLeft":
                container.style.top = `${5 + targetElement.offsetHeight}px`;
                container.style.left = "5px";
                break;
              case "bottomRight":
                container.style.top = `${5 + targetElement.offsetHeight}px`;
                container.style.right = "5px";
                break;
              case "topRight":
                container.style.top = "5px";
                container.style.left = `${targetElement.offsetWidth}px`;
                break;
              case "above":
                container.style.bottom = `${targetElement.offsetHeight}px`;
                container.style.left = "5px";
                break;
              default:
                container.style.top = `${5 + targetElement.offsetHeight}px`;
                container.style.left = "5px";
                break;
            }
            container._logicalParent = targetElement;
            control.render(XNode.create("div", null, " ", XNode.create("atom-popup-container", null, node), " "), container, control);
            targetElement.insertAdjacentElement("beforeend", container);
            return yield new Promise((resolve, reject) => {
              var _a;
              const disposables = new AtomDisposableList();
              disposables.add(() => targetElement.removeAttribute("data-popup-open"));
              let resolved = false;
              const close = r => {
                if (resolved) {
                  return;
                }
                resolved = true;
                resolve(r);
                disposables.dispose();
              };
              const cancel = (r = "cancelled") => {
                if (resolved) {
                  return;
                }
                resolved = true;
                reject(r);
                disposables.dispose();
              };
              const firstChild = container.firstElementChild.atomControl;
              if (firstChild instanceof InlinePopup) {
                firstChild.cancel = cancel;
                firstChild.close = close;
              } else {
                if (options.onClick === void 0) {
                  options.onClick = options.defaultOnClick;
                }
              }
              const defaultClose = options.onClick === "close" ? close : cancel;
              const observer = new MutationObserver(() => {
                if (!container.isConnected) {
                  defaultClose();
                }
              });
              observer.observe(targetElement, {
                childList: true
              });
              disposables.add(() => {
                observer.disconnect();
                control.dispose(container);
                container.remove();
              });
              if (options.onClick) {
                disposables.add(control.bindEvent(container, "click", () => __awaiter(this, void 0, void 0, function* () {
                  yield sleep(200);
                  defaultClose();
                })));
              }
              (_a = options.cancelToken) === null || _a === void 0 ? void 0 : _a.registerForCancel(cancel);
              disposables.add(closeHandler(targetElement, container, defaultClose));
            });
          });
        }
        static showControl(target, options = {}) {
          const node = XNode.create(this, {});
          return this.show(target, node, options);
        }
        dispatchClickEvent(e, data) {
          let start = this.element.parentElement;
          while (start) {
            const atomControl = AtomControl.from(start);
            if (atomControl) {
              atomControl.dispatchClickEvent(e, data);
              return;
            }
            start = start.parentElement;
          }
          super.dispatchClickEvent(e, data);
        }
      });
      document.body.addEventListener("click", e => {
        let start = e.target;
        let popupFactory;
        let alignment;
        while (start) {
          popupFactory = start.popupFactory;
          if (popupFactory) {
            alignment = start.dataset.alignment;
            break;
          }
          start = start.parentElement;
        }
        if (!start) {
          return;
        }
        if (start.getAttribute("data-popup-open")) {
          return;
        }
        start.setAttribute("data-popup-open", "true");
        const control = AtomControl.from(start);
        const app = control.app;
        const target = start;
        const element = control.element;
        let itemIndex;
        let data;
        if (control.items && control.itemRenderer) {
          while (start && start !== element) {
            itemIndex !== null && itemIndex !== void 0 ? itemIndex : itemIndex = start.getAttribute("data-item-index");
            if (itemIndex) {
              data = control.items[~~itemIndex];
              break;
            }
            start = start.parentElement;
          }
        }
        if (!data) {
          data = new Proxy(target, {
            get(t, p, receiver) {
              let s = target;
              while (s) {
                const v = s.dataset[p];
                if (v !== void 0) {
                  return v;
                }
                s = s.parentElement;
              }
            }
          });
        }
        const node = popupFactory(data);
        const defaultOnClick = target.getAttribute("data-default-on-click");
        app.runAsync(() => InlinePopup.show(target, node, {
          alignment,
          defaultOnClick
        }));
      });
      ElementValueSetters["data-popup-class"] = (c, e, v) => {
        e.popupFactory = v;
      };
    }
  };
});
//# sourceMappingURL=InlinePopup.js.map