System.register(["tslib", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "./elements/AtomPopover"], function (_export, _context) {
  "use strict";

  var __rest, XNode, AtomControl, AtomPopover;
  function InlinePopupButton(_a, ...nodes) {
    var _b, _c;
    var {
        icon,
        text,
        label,
        closeOnClick = true,
        popup
      } = _a,
      a = __rest(_a, ["icon", "text", "label", "closeOnClick", "popup"]);
    if (!a["anchor-right"]) {
      (_b = a["anchor-left"]) !== null && _b !== void 0 ? _b : a["anchor-left"] = "parent-right";
    }
    if (!a["anchor-bottom"]) {
      (_c = a["anchor-top"]) !== null && _c !== void 0 ? _c : a["anchor-top"] = "parent-top";
    }
    a["data-atom-popup-button"] = "popup-button";
    if (!popup) {
      const copy = nodes;
      const div = XNode.create("div", null, ...copy);
      popup = () => div;
      nodes = [];
    }
    a["popupFactory"] = popup;
    if (closeOnClick) {
      a["data-close-on-click"] = true;
    }
    if (!a["data-layout"]) {
      if (icon && text) {
        a["data-layout"] = "icon-button";
      } else {
        a["data-layout"] = "button";
      }
    }
    return XNode.create("button", Object.assign({
      "data-inline-popup-button": "inline-popup-button",
      "data-atom-popup-button": "1"
    }, a), icon && XNode.create("i", {
      class: icon
    }), text && XNode.create("span", {
      text: text
    }), label && XNode.create("label", {
      text: text
    }), ...nodes);
  }
  _export("default", InlinePopupButton);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_elementsAtomPopover) {
      AtomPopover = _elementsAtomPopover.default;
    }],
    execute: function () {
      document.body.addEventListener("click", e => {
        let start = e.target;
        while (start) {
          if (start.hasAttribute("data-atom-popup-button")) {
            break;
          }
          start = start.parentElement;
        }
        if (!start) {
          return;
        }
        const pf = start["popupFactory"];
        if (!pf) {
          return;
        }
        const control = AtomControl.from(start);
        const app = control.app;
        const target = start;
        const element = control.element;
        const dataFactory = () => {
          let itemIndex;
          let data;
          if (control.items && control.itemRenderer) {
            while (start && start !== element) {
              itemIndex !== null && itemIndex !== void 0 ? itemIndex : itemIndex = start.getAttribute("data-item-index");
              if (itemIndex) {
                data = control.items[~~itemIndex];
                break;
              }
              start = start.parentElement;
            }
          }
          if (!data) {
            data = new Proxy(target, {
              get(t, p, receiver) {
                let s = target;
                while (s) {
                  const v = s.dataset[p];
                  if (v !== void 0) {
                    return v;
                  }
                  s = s.parentElement;
                }
              }
            });
          }
          return data;
        };
        let closeOnClick = void 0;
        const dataCloseOnClick = target.getAttribute("data-close-on-click");
        if (dataCloseOnClick) {
          closeOnClick = /^(true|yes|1)$/i.test(dataCloseOnClick);
        }
        AtomPopover.create(target, {
          nodeFactory: data => pf(data),
          dataFactory,
          closeOnClick,
          "anchor-bottom": target.getAttribute("anchor-bottom"),
          "anchor-top": target.getAttribute("anchor-top"),
          "anchor-left": target.getAttribute("anchor-left"),
          "anchor-right": target.getAttribute("anchor-right")
        });
      });
    }
  };
});
//# sourceMappingURL=InlinePopupButton.js.map