System.register(["tslib", "@web-atoms/core/dist/core/XNode", "./styles/masked-input.global.css"], function (_export, _context) {
  "use strict";

  var __rest, XNode, updateMask;
  function MaskedInput(_a) {
    var {
        mask
      } = _a,
      a = __rest(_a, ["mask"]);
    return XNode.create("input", Object.assign({
      "data-mask": mask,
      "event-change": updateMask,
      "event-keypress": updateMask,
      "event-keyup": updateMask
    }, a));
  }
  _export("default", MaskedInput);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_stylesMaskedInputGlobalCss) {}],
    execute: function () {
      updateMask = e => {
        const target = e.target;
        const mask = target.dataset.mask;
        if (!mask) {
          return;
        }
        let result = "";
        const value = target.value;
        for (let index = 0, elementIndex = 0; elementIndex < value.length; elementIndex++, index++) {
          const element = value[elementIndex];
          const maskElement = mask[index];
          switch (maskElement) {
            case "#":
              result += /[0-9]/.test(element) ? element : "";
              continue;
            case ".":
              if (element !== ".") {
                result += ".";
              }
              result += element;
              break;
          }
        }
        if (target.value !== result) {
          target.value = result;
        }
      };
    }
  };
});
//# sourceMappingURL=MaskedInput.js.map