System.register(["tslib", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/core/XNode"], function (_export, _context) {
  "use strict";

  var __rest, AtomControl, XNode, labelPathSetter, valuePathSetter, valueSetter, refreshItems, itemsSetter;
  function Select(_a) {
    var {
        items,
        labelPath,
        valuePath,
        value
      } = _a,
      a = __rest(_a, ["items", "labelPath", "valuePath", "value"]);
    a[labelPathSetter.property] = labelPath;
    a[valuePathSetter.property] = valuePath;
    a[valueSetter.property] = value;
    a[itemsSetter.property] = items;
    return XNode.create("select", Object.assign({}, a));
  }
  _export("default", Select);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }],
    execute: function () {
      labelPathSetter = AtomControl.registerProperty("data-items", "value", (ctrl, element, value) => {
        element["labelPath"] = value;
      });
      valuePathSetter = AtomControl.registerProperty("data-items", "value", (ctrl, element, value) => {
        element["valuePath"] = value;
      });
      valueSetter = AtomControl.registerProperty("data-items", "value", (ctrl, element, value) => {
        var _a;
        element["initialValue"] = value;
        element["value"] = value;
        const select = element;
        let length = select.options.length;
        if (!length) {
          setTimeout(refreshItems, 1, element);
          return;
        }
        const items = element["items"];
        if (!items) {
          setTimeout(refreshItems, 1, element);
          return;
        }
        const vp = (_a = element["valuePath"]) !== null && _a !== void 0 ? _a : item => {
          var _a;
          return (_a = item === null || item === void 0 ? void 0 : item.value) !== null && _a !== void 0 ? _a : item;
        };
        let index = 0;
        for (const item of items) {
          const v = vp(item);
          if (v == value) {
            select.selectedIndex = index;
            return;
          }
          index++;
        }
        setTimeout(refreshItems, 1, element);
      });
      refreshItems = (element, items) => {
        var _a, _b;
        items !== null && items !== void 0 ? items : items = element["items"];
        element.update = true;
        const old = element.selectedIndex;
        let cv = element["initialValue"];
        if (old !== -1) {
          cv = element["value"];
        }
        element.options.length = 0;
        const lp = (_a = element["labelPath"]) !== null && _a !== void 0 ? _a : item => {
          var _a;
          return (_a = item === null || item === void 0 ? void 0 : item.label) !== null && _a !== void 0 ? _a : item;
        };
        const vp = (_b = element["valuePath"]) !== null && _b !== void 0 ? _b : item => {
          var _a;
          return (_a = item === null || item === void 0 ? void 0 : item.value) !== null && _a !== void 0 ? _a : item;
        };
        let i = 0;
        let si = -1;
        if (items === null || items === void 0 ? void 0 : items.length) {
          for (const iterator of items) {
            const option = document.createElement("option");
            const label = lp(iterator);
            const value = vp(iterator);
            option.text = label;
            option.value = value;
            element.options.add(option);
            if (cv !== void 0) {
              if (cv == value) {
                si = i;
              }
            }
            i++;
          }
        }
        if (si != -1) {
          element.selectedIndex = si;
        }
        element.update = false;
      };
      itemsSetter = AtomControl.registerProperty("data-items", "value", (ctrl, element, value) => {
        element["items"] = value;
        setTimeout(refreshItems, 1, element, value);
      });
    }
  };
});
//# sourceMappingURL=Select.js.map