System.register(["@web-atoms/core/dist/core/AtomBinder", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/date-time/dist/TimeSpan", "./Select", "@web-atoms/core/dist/core/Bind", "./styles/time-editor.global.css"], function (_export, _context) {
  "use strict";

  var AtomBinder, XNode, AtomControl, TimeSpan, Select, Bind, TimeEditor;
  function hours() {
    return [{
      label: "01",
      value: 1
    }, {
      label: "02",
      value: 2
    }, {
      label: "03",
      value: 3
    }, {
      label: "04",
      value: 4
    }, {
      label: "05",
      value: 5
    }, {
      label: "06",
      value: 6
    }, {
      label: "07",
      value: 7
    }, {
      label: "08",
      value: 8
    }, {
      label: "09",
      value: 9
    }, {
      label: "10",
      value: 10
    }, {
      label: "11",
      value: 11
    }, {
      label: "12",
      value: 12
    }];
  }
  function minutes() {
    const items = [];
    for (let index = 0; index < 10; index++) {
      items.push({
        label: "0" + index,
        value: index
      });
    }
    for (let index = 10; index < 60; index++) {
      items.push({
        label: index.toString(),
        value: index
      });
    }
    return items;
  }
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistCoreAtomBinder) {
      AtomBinder = _webAtomsCoreDistCoreAtomBinder.AtomBinder;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsDateTimeDistTimeSpan) {
      TimeSpan = _webAtomsDateTimeDistTimeSpan.default;
    }, function (_Select) {
      Select = _Select.default;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_stylesTimeEditorGlobalCss) {}],
    execute: function () {
      _export("default", TimeEditor = class TimeEditor extends AtomControl {
        get time() {
          let t = new TimeSpan(0, this.hour, this.minute);
          if (this.isPM) {
            t = t.add(TimeSpan.fromHours(12));
          }
          return t;
        }
        set time(v) {
          if (!v) {
            v = TimeSpan.fromSeconds(0);
          }
          let h = v.hours;
          if (h > 12) {
            h -= 12;
            this.isPM = true;
          }
          this.hour = h;
          this.minute = v.minutes;
          AtomBinder.refreshValue(this, "time");
        }
        create() {
          this.isPM = false;
          this.hour = 12;
          this.minute = 0;
          this.render(XNode.create("div", {
            "data-time-editor": "time-editor",
            "event-change": () => setTimeout(() => AtomBinder.refreshValue(this, "time"), 1)
          }, XNode.create(Select, {
            "data-element": "hour",
            items: hours(),
            value: Bind.twoWays(() => this.hour)
          }), XNode.create(Select, {
            "data-element": "minute",
            items: minutes(),
            value: Bind.twoWays(() => this.minute)
          }), XNode.create("button", {
            "event-click": () => (this.isPM = false, AtomBinder.refreshValue(this, "time")),
            "data-selected": Bind.oneWay(() => !this.isPM),
            "data-element": "am",
            text: "AM"
          }), XNode.create("button", {
            "event-click": () => (this.isPM = true, AtomBinder.refreshValue(this, "time")),
            "data-selected": Bind.oneWay(() => this.isPM),
            "data-element": "pm",
            text: "PM"
          })));
        }
      });
    }
  };
});
//# sourceMappingURL=TimeEditor.js.map