System.register(["tslib", "@web-atoms/core/dist/core/XNode", "./styles/title-editor.global.css"], function (_export, _context) {
  "use strict";

  var __rest, XNode, paste, formatText, capitalizeText, toText, changeCase;
  function TitleEditor(_a) {
    var {
        value,
        type,
        placeholder,
        capitalize = "on",
        capitalizationTitle = "Capitalization"
      } = _a,
      a = __rest(_a, ["value", "type", "placeholder", "capitalize", "capitalizationTitle"]);
    return XNode.create("div", Object.assign({
      "data-title-editor": "title-editor"
    }, a), XNode.create("input", {
      autocapitalize: capitalize,
      type: type,
      placeholder: placeholder,
      value: value,
      "event-input": capitalizeText,
      "event-paste": paste
    }), XNode.create("i", {
      "data-element": "icon",
      class: "fas fa-font-case",
      "event-click": changeCase,
      title: capitalizationTitle
    }), XNode.create("span", {
      "data-element": "text",
      text: toText(capitalize),
      "event-click": changeCase,
      title: capitalizationTitle
    }));
  }
  _export("default", TitleEditor);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_stylesTitleEditorGlobalCss) {}],
    execute: function () {
      paste = e => {
        const input = e.target;
        const capitalize = input.autocapitalize;
        if (!capitalize || capitalize === "off" || capitalize === "none") {
          return;
        }
        setTimeout(() => {
          const start = input.selectionStart;
          const end = input.selectionEnd;
          formatText(input, capitalize);
          input.setSelectionRange(start, end);
        }, 1);
      };
      formatText = (input, capitalize, all = true) => {
        let value = input.value;
        if (!value) {
          return;
        }
        switch (capitalize) {
          case "on":
          case "sentences":
            if (value.length === 1) {
              value = value.toLocaleUpperCase();
            }
            break;
          case "words":
            if (all) {
              value = value.replace(/(\S+)/g, s => s.substring(0, 1).toLocaleUpperCase() + s.substring(1));
            } else {
              value = value.replace(/(\S+)$/g, s => s.substring(0, 1).toLocaleUpperCase() + s.substring(1));
            }
            break;
          case "characters":
            value = value.toLocaleUpperCase();
            break;
        }
        input.value = value;
      };
      capitalizeText = /android|iPhone|iOS/i.test(navigator.userAgent) ? () => undefined : e => {
        const input = e.target;
        const capitalize = input.autocapitalize;
        if (!capitalize || capitalize === "off" || capitalize === "none") {
          return;
        }
        const start = input.selectionStart;
        const end = input.selectionEnd;
        formatText(input, capitalize, false);
        input.setSelectionRange(start, end);
      };
      toText = capitalize => {
        switch (capitalize) {
          case "off":
          case "none":
            return "Caps Off";
          case "characters":
            return "All Caps";
          case "on":
          case "sentences":
            return "Sentence";
          case "words":
            return "Title Case";
        }
        return "";
      };
      changeCase = e => {
        let element = e.target;
        if (element.tagName === "SPAN") {
          element = element.previousElementSibling;
        }
        const input = element.previousElementSibling;
        const span = element.nextElementSibling;
        let capitalize = input.autocapitalize;
        switch (capitalize) {
          case "sentences":
            capitalize = "words";
            break;
          case "words":
            capitalize = "characters";
            break;
          case "characters":
            capitalize = "off";
            break;
          default:
            capitalize = "sentences";
            break;
        }
        span.textContent = toText(capitalize);
        input.autocapitalize = capitalize;
      };
    }
  };
});
//# sourceMappingURL=TitleEditor.js.map