export declare const isFileType: (acceptType: string) => any;
export type FilesAvailableEventArgs<T = any> = CustomEvent<{
    files: File[];
    extra: T;
    maxSize: number;
    convert: boolean;
    uploadEvent: string;
}>;
export interface IUploadParams<T = any> {
    "event-files-available"?: (ce: FilesAvailableEventArgs<T>) => any;
    uploadEvent?: string;
    accept?: string;
    capture?: string;
    multiple?: any;
    /** Will enforce that the selected file matches the given accept types */
    forceType?: boolean;
    maxSize?: number;
    /** Used for inline video conversion, you must handle conversion before upload by yourself. */
    convert?: boolean;
    /** Used for inline video streaming, you must handle the streaming yourself */
    stream?: boolean;
    /** Max file size for streaming */
    maxStreamSize?: number;
    upload?: boolean;
    /** Extra will hold other information that will be available in upload event */
    extra?: T;
    authorize?: boolean;
    ariaLabel?: string;
    folder?: boolean;
}
export default class UploadEvent {
    static requestUpload: ({ element, multiple, authorize, extra, convert, upload, folder, stream, maxStreamSize, uploadEvent }: {
        element: HTMLElement;
        multiple?: boolean;
        authorize?: boolean;
        extra?: any;
        convert?: boolean;
        stream?: boolean;
        maxStreamSize?: number;
        upload?: boolean;
        folder?: boolean;
        uploadEvent?: string;
    }) => void;
    static AttachUploadAction({ uploadEvent, accept, capture, multiple, forceType, maxSize, maxStreamSize, stream, extra, convert, upload, authorize, ariaLabel, folder, ...others }: IUploadParams): {
        "data-folder": string;
        "data-click-command": string;
        "data-upload-event": string;
        "data-accept": string;
        "data-multiple": string;
        "data-capture": string;
        "data-convert": boolean;
        "data-stream": string;
        "data-max-stream-size": string;
        "data-upload": string;
        "data-force-type": string;
        "data-max-size": string;
        "data-authorize": string;
        "aria-label": string;
        extra: any;
        "event-files-available"?: (ce: FilesAvailableEventArgs<any>) => any;
    };
}
//# sourceMappingURL=UploadEvent.d.ts.map