import { AtomDisposableList } from "@web-atoms/core/dist/core/AtomDisposableList";
import { CancelToken } from "@web-atoms/core/dist/core/types";
import XNode, { IElementAttributes } from "@web-atoms/core/dist/core/XNode";
import { AtomControl } from "@web-atoms/core/dist/web/controls/AtomControl";
import "./AtomPopover.css";
export interface IAnchorPopover extends IElementAttributes {
    "anchor-left"?: "parent-left" | "parent-right";
    "anchor-right"?: "parent-left" | "parent-right";
    "anchor-top"?: "parent-top" | "parent-bottom";
    "anchor-bottom"?: "parent-top" | "parent-bottom";
}
declare global {
    namespace JSX {
        interface IntrinsicElements {
            "atom-pop-over": IAnchorPopover;
        }
    }
}
export interface IAtomPopoverOptions {
    nodeFactory?: (data: any) => XNode | HTMLElement;
    dataFactory?: () => any;
    "anchor-left"?: "parent-left" | "parent-right";
    "anchor-right"?: "parent-left" | "parent-right";
    "anchor-top"?: "parent-top" | "parent-bottom";
    "anchor-bottom"?: "parent-top" | "parent-bottom";
    closeOnClick?: boolean;
    cancelToken?: CancelToken;
}
export default abstract class AtomPopover<T = any> {
    owner: AtomControl;
    popover: HTMLElement;
    result: any;
    disposables: AtomDisposableList;
    resultPromise: Promise<T>;
    resultResolve: (value: T | PromiseLike<T>) => void;
    resultReject: (reason?: any) => void;
    parent: HTMLElement;
    popoverContainer: HTMLElement;
    static create(parent: HTMLElement | AtomControl, options?: IAtomPopoverOptions): any;
    static show<T1 = any>(parent: HTMLElement | AtomControl, options?: IAtomPopoverOptions): Promise<T1>;
    static menu(parent: HTMLElement | AtomControl, node: HTMLElement | XNode): AtomPopover<any>;
    set renderer(v: XNode | HTMLElement);
    constructor(parent: HTMLElement | AtomControl, options?: IAtomPopoverOptions);
    abstract init(data?: any): any;
    close(r: any): void;
    cancel(): Promise<void>;
    removing: (ce?: Event) => void;
    remove: () => void;
}
//# sourceMappingURL=AtomPopover.d.ts.map