System.register([], function (_export, _context) {
  "use strict";

  var getScreenRect;
  function relativeRect(e, cb) {
    const ebr = getScreenRect(e);
    const cbr = getScreenRect(cb);
    let left = ebr.left;
    let top = ebr.top;
    let bottom = ebr.bottom;
    let right = ebr.right;
    if (cb.offsetParent) {
      left -= cbr.left;
      top -= cbr.top;
      bottom -= cbr.bottom;
      right -= cbr.right;
    }
    const height = e.offsetHeight;
    const width = e.offsetWidth;
    return {
      left,
      top,
      bottom,
      right,
      width,
      height,
      e
    };
  }
  _export("relativeRect", relativeRect);
  return {
    setters: [],
    execute: function () {
      getScreenRect = e => {
        const {
          left,
          top,
          height,
          width
        } = e.getBoundingClientRect();
        const right = visualViewport.width - left - width;
        const bottom = visualViewport.height - top - height;
        return {
          left,
          top,
          right,
          bottom,
          height,
          width
        };
      };
    }
  };
});
//# sourceMappingURL=relativeRect.js.map