System.register(["tslib", "@web-atoms/core/dist/App", "@web-atoms/core/dist/di/Inject", "@web-atoms/core/dist/view-model/AtomViewModel", "./AtomColumn"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, App, Inject, AtomViewModel, Watch, AtomColumn, AtomDataGridViewModel;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistApp) {
      App = _webAtomsCoreDistApp.App;
    }, function (_webAtomsCoreDistDiInject) {
      Inject = _webAtomsCoreDistDiInject.Inject;
    }, function (_webAtomsCoreDistViewModelAtomViewModel) {
      AtomViewModel = _webAtomsCoreDistViewModelAtomViewModel.AtomViewModel;
      Watch = _webAtomsCoreDistViewModelAtomViewModel.Watch;
    }, function (_AtomColumn) {
      AtomColumn = _AtomColumn.default;
    }],
    execute: function () {
      _export("default", AtomDataGridViewModel = class AtomDataGridViewModel extends AtomViewModel {
        watchInit() {
          if (!this.owner) {
            return;
          }
          const data = this.owner.items;
          if (!data) {
            return;
          }
          let columns = this.owner.columns;
          if (columns && columns.length) {
            return;
          }
          const columnList = {};
          columns = [];
          for (const iterator of data) {
            for (const key in iterator) {
              if (columnList[key]) {
                continue;
              }
              if (iterator.hasOwnProperty(key)) {
                const v = iterator[key];
                const c = new AtomColumn(this.app);
                c.label = key;
                c.labelPath = key;
                c.valuePath = key;
                c.align = "left";
                if (typeof v !== "string") {
                  c.align = "right";
                  c.sort = (a, b) => a > b ? -1 : 1;
                } else {
                  c.sort = (a, b) => a.localeCompare(b);
                }
                columns.push(c);
                columnList[key] = c;
              }
            }
          }
          setTimeout(() => {
            this.owner.columns = columns;
          }, 1);
        }
        getItem(data, valuePath) {
          return data[valuePath];
        }
      });
      __decorate([Inject, __metadata("design:type", App)], AtomDataGridViewModel.prototype, "app", void 0);
      __decorate([Watch, __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], AtomDataGridViewModel.prototype, "watchInit", null);
    }
  };
});
//# sourceMappingURL=AtomDataGridViewModel.js.map