System.register(["@web-atoms/core/dist/web/controls/AtomControl"], function (_export, _context) {
  "use strict";

  var AtomControl;
  function GridTemplate(owner, templatePath, elementName) {
    return class AtomGridTemplate extends AtomControl {
      constructor(app, e = document.createElement("tr")) {
        super(app, e);
        this.lastCreateRowId = null;
      }
      preCreate() {
        this.dataGrid = owner;
        this.row = null;
        this.data = null;
        this.bind(this.element, "none", [["this", "data"], ["this", "dataGrid", "columns"]], false, (data, columns) => this.updateRow(data, columns), this);
      }
      updateRow(data, columns) {
        if (this.columnDisposable) {
          this.columnDisposable.dispose();
          this.columnDisposable = null;
        }
        if (!columns) {
          return;
        }
        this.columnDisposable = this.disposables.add(columns.watch(() => {
          this.deferCreateRow(data, columns);
        }));
        this.createRow(data, columns);
        return 1;
      }
      deferCreateRow(data, columns) {
        if (this.lastCreateRowId) {
          clearTimeout(this.lastCreateRowId);
          this.lastCreateRowId = null;
        }
        this.lastCreateRowId = setTimeout(() => this.createRow(data, columns), 100);
      }
      createRow(data, columns) {
        if (this.row) {
          for (const iterator of this.row) {
            const e = iterator.element;
            if (e) {
              iterator.dispose();
              e.remove();
            }
          }
          this.row = null;
        }
        this.row = columns.map(x => {
          const c = new x[templatePath](this.app, document.createElement(elementName));
          c.data = data;
          this.append(c);
          return c;
        });
      }
    };
  }
  _export("default", GridTemplate);
  return {
    setters: [function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }],
    execute: function () {}
  };
});
//# sourceMappingURL=GridTemplate.js.map