System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/Colors", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/view-model/AtomViewModel", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/controls/AtomItemsControl", "@web-atoms/core/dist/web/styles/AtomStyle"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, Bind, Colors, XNode, AtomViewModel, Watch, AtomControl, AtomItemsControl, AtomStyle, AtomDataPagerViewModel, AtomDataPagerStyle, AtomDataPager;
  _export({
    AtomDataPagerViewModel: void 0,
    AtomDataPagerStyle: void 0,
    default: void 0
  });
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreColors) {
      Colors = _webAtomsCoreDistCoreColors.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistViewModelAtomViewModel) {
      AtomViewModel = _webAtomsCoreDistViewModelAtomViewModel.AtomViewModel;
      Watch = _webAtomsCoreDistViewModelAtomViewModel.Watch;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebControlsAtomItemsControl) {
      AtomItemsControl = _webAtomsCoreDistWebControlsAtomItemsControl.AtomItemsControl;
    }, function (_webAtomsCoreDistWebStylesAtomStyle) {
      AtomStyle = _webAtomsCoreDistWebStylesAtomStyle.AtomStyle;
    }],
    execute: function () {
      _export("AtomDataPagerViewModel", AtomDataPagerViewModel = class AtomDataPagerViewModel extends AtomViewModel {
        get pages() {
          const r = [];
          const size = this.owner.size;
          if (size <= 0) {
            return r;
          }
          const total = Math.ceil(this.owner.total / size);
          let current = this.owner.current;
          if (current === null) {
            current = 0;
            this.owner.current = 0;
          }
          if (current >= total) {
            current = total - 1;
          }
          const start = Math.max(0, current <= 2 ? 0 : current + 5 > total ? total - 5 : current - 3);
          const max = Math.min(start + 5, total);
          for (let index = start; index < max; index++) {
            r.push({
              label: `${index + 1}`,
              value: index
            });
          }
          return r;
        }
      });
      __decorate([Watch, __metadata("design:type", Object), __metadata("design:paramtypes", [])], AtomDataPagerViewModel.prototype, "pages", null);
      _export("AtomDataPagerStyle", AtomDataPagerStyle = class AtomDataPagerStyle extends AtomStyle {
        get root() {
          return {
            subclasses: {
              " button": {
                margin: "5px"
              },
              " button.selected": {
                margin: "5px",
                backgroundColor: Colors.blue,
                color: Colors.white
              }
            }
          };
        }
      });
      _export("default", AtomDataPager = class AtomDataPager extends AtomControl {
        create() {
          this.defaultControlStyle = AtomDataPagerStyle;
          this.current = 0;
          this.size = 0;
          this.total = 0;
          this.localViewModel = this.resolve(AtomDataPagerViewModel, "owner");
          this.render(XNode.create("div", {
            styleClass: this.controlStyle.name
          }, XNode.create("button", {
            eventClick: Bind.event(() => this.current = 0),
            text: "First"
          }), XNode.create(AtomItemsControl, {
            for: "span",
            items: Bind.oneWay(() => this.localViewModel.pages)
          }, XNode.create(AtomItemsControl.itemTemplate, null, XNode.create("button", {
            styleClass: Bind.oneWay(x => ({
              item: 1,
              selected: x.data.value === this.current
            })),
            eventClick: Bind.event(x => this.current = x.data.value),
            text: Bind.oneTime(x => x.data.label)
          }))), XNode.create("button", {
            eventClick: Bind.event(() => this.current = this.total > 0 ? Math.floor(this.total / this.size) : 0),
            text: "Last"
          })));
        }
      });
    }
  };
});
//# sourceMappingURL=AtomDataPager.js.map