System.register(["../mobile-app/MobileApp", "./DesktopApp", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/services/PopupService"], function (_export, _context) {
  "use strict";

  var MobileApp, isMobileView, DesktopApp, XNode, PopupService, MobileDesktopApp, T;
  _export("default", void 0);
  return {
    setters: [function (_mobileAppMobileApp) {
      MobileApp = _mobileAppMobileApp.default;
      isMobileView = _mobileAppMobileApp.isMobileView;
    }, function (_DesktopApp) {
      DesktopApp = _DesktopApp.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebServicesPopupService) {
      PopupService = _webAtomsCoreDistWebServicesPopupService.default;
    }],
    execute: function () {
      T = isMobileView ? MobileApp : DesktopApp;
      _export("default", MobileDesktopApp = class MobileDesktopApp extends T {
        get drawerMenu() {
          return this.menu;
        }
        set drawerMenu(v) {
          this.menu = v;
          if (this.mobileApp) {
            this.mobileApp.drawer = v;
          } else {
            this.desktopApp.menuRenderer = () => XNode.create(v, {});
          }
        }
        preCreate() {
          MobileDesktopApp.current = this;
          super.preCreate();
          if (isMobileView) {
            this.mobileApp = this;
          } else {
            this.desktopApp = this;
          }
          this.runAfterInit(() => PopupService.lastTarget = this.element);
        }
      });
    }
  };
});
//# sourceMappingURL=MobileDesktopApp.js.map