import { BaseService } from "@web-atoms/core/dist/services/http/RestService";
import { AtomControl } from "@web-atoms/core/dist/web/controls/AtomControl";
import "@web-atoms/data-styles/data-styles";
import { CancelToken } from "@web-atoms/core/dist/core/types";
import "./Devhost.global.css";
export declare class FileService extends BaseService {
    getModules(search: string, packed: boolean, cancelToken: CancelToken): Promise<IFilePath[]>;
    private getRemoteModules;
}
export default class AppHost extends AtomControl {
    search: string;
    designMode: boolean;
    fileType: string;
    private fileService;
    init(): Promise<void>;
    getModules(search: string, packed: boolean, cancelToken: CancelToken): Promise<IFilePath[]>;
    protected preCreate(): void;
    protected copyUrl(url: string): Promise<void>;
}
export interface IFilePath {
    name: string;
    base: string;
    dir: string;
    ext: string;
    root: string;
    url: string;
    hostUrl?: string;
    package?: string;
    visible: boolean;
    packed?: boolean;
    module?: string;
}
export interface IFilePathResult {
    files: IFilePath[];
}
//# sourceMappingURL=DevHost.d.ts.map