System.register(["@web-atoms/core/dist/web/controls/AtomControl", "./AtomFormStyle", "@web-atoms/core/dist/core/Hacks"], function (_export, _context) {
  "use strict";

  var AtomControl, AtomFormStyle, refreshInherited, AtomForm;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_AtomFormStyle) {
      AtomFormStyle = _AtomFormStyle.default;
    }, function (_webAtomsCoreDistCoreHacks) {
      refreshInherited = _webAtomsCoreDistCoreHacks.refreshInherited;
    }],
    execute: function () {
      _export("default", AtomForm = class AtomForm extends AtomControl {
        constructor() {
          super(...arguments);
          this.focusNextOnEnter = /mobile/i.test(navigator.userAgent);
        }
        preCreate() {
          super.preCreate();
          this.defaultControlStyle = AtomFormStyle;
          this.runAfterInit(() => {
            this.element.classList.add(this.controlStyle.name);
            this.app.callLater(() => {
              refreshInherited(this, "viewModel");
              refreshInherited(this, "localViewModel");
              refreshInherited(this, "data");
            });
            this.watchKeyInput();
          });
        }
        watchKeyInput() {
          this.bindEvent(this.element, "keypress", e => {
            this.onKeyPress(e);
          });
        }
        onKeyPress(e) {
          if (!this.focusNextOnEnter) {
            return;
          }
          const target = e.target;
          if (!/input/i.test(target.tagName)) {
            return;
          }
          const input = target;
          if (e.keyCode === 13) {
            if (/submit/i.test(input.className)) {
              this.fireSubmitEvent(input);
              return;
            }
            const next = this.focusNextInput(target);
            if (next) {
              next.focus();
            } else {
              this.fireSubmitEvent(input);
            }
          }
        }
        fireSubmitEvent(target) {
          target.dispatchEvent(new Event("change"));
          this.app.callLater(() => {
            const e = new CustomEvent("submit", {
              bubbles: false,
              cancelable: false
            });
            this.element.dispatchEvent(e);
          });
        }
        focusNextInput(target) {
          let found = false;
          let result = null;
          function find(e) {
            if (result) {
              return;
            }
            const isText = /input|textarea/i.test(e.tagName);
            if (found) {
              if (isText) {
                result = e;
                return;
              }
            }
            if (e === target) {
              found = true;
            }
            const child = e.firstElementChild;
            if (child) {
              find(child);
            }
            const next = e.nextElementSibling;
            if (next) {
              find(next);
            }
          }
          find(document.body);
          return result;
        }
      });
    }
  };
});
//# sourceMappingURL=AtomForm.js.map