System.register([], function (_export, _context) {
  "use strict";

  var RangeEditor, checkAnyParent, updateAttribute, updateStyle, RangeEditorCommands;
  _export("default", void 0);
  return {
    setters: [],
    execute: function () {
      _export("checkAnyParent", checkAnyParent = check => e => {
        while (e) {
          if (check(e)) {
            return true;
          }
          e = e.parentElement;
        }
        return false;
      });
      _export("default", RangeEditor = class RangeEditor {
        static updateAttribute(range, name, value, anyParent = true) {
          return this.updateRange({
            range,
            check: anyParent ? checkAnyParent(e => e.getAttribute(name) === value) : e => e.getAttribute(name) === value,
            update: e => (e.setAttribute(name, value), e)
          });
        }
        static checkRange({
          range,
          check
        }) {
          const root = range.startContainer.nodeType !== Node.ELEMENT_NODE ? range.startContainer.parentElement : range.startContainer;
          return check(root);
        }
        static updateRange({
          range,
          check,
          update,
          value
        }) {}
      });
      updateAttribute = (name, value, anyParent = true) => ({
        update: (e, v = value) => (e.setAttribute(name, v), e),
        check: anyParent ? checkAnyParent(e => e.getAttribute(name) === value) : e => e.getAttribute(name) === value
      });
      updateStyle = (name, value, anyParent = true) => ({
        update: (e, v = value) => (e.style[name] = v, e),
        check: anyParent ? checkAnyParent(e => e.style[name] === value) : e => e.style[name] === value
      });
      _export("RangeEditorCommands", RangeEditorCommands = {
        bold: updateStyle("fontWeight", "bold"),
        italic: updateStyle("fontStyle", "italic"),
        underline: updateStyle("textDecoration", "underline"),
        strikeThrough: updateStyle("textDecoration", "line-through"),
        foreColor: {
          check: () => false,
          update: (e, value) => {
            e.style.color = value;
            return e;
          }
        },
        removeFormat: {
          check: () => false,
          update: e => {
            e.removeAttribute("style");
            return e;
          }
        }
      });
    }
  };
});
//# sourceMappingURL=RangeEditor.js.map