System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/services/PopupService", "../../basic/FormField", "./CommandButton", "./HtmlCommands"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, Bind, BindableProperty, XNode, PopupService, PopupWindow, FormField, CommandButton, HtmlCommands, ImageDialog;
  function showImageDialog(s, e) {
    return PopupService.showWindow(e.currentTarget, ImageDialog, {
      title: "Add Image"
    });
  }
  function AddImage({
    eventInsertHtml = (s, e) => s.insertImage(s, e),
    insertCommand = HtmlCommands.insertImage
  }) {
    return CommandButton({
      icon: "ri-image-add-fill",
      insertCommand,
      disabled: false,
      title: "Insert Image",
      eventInsertHtml
    });
  }
  _export({
    showImageDialog: showImageDialog,
    default: AddImage
  });
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebServicesPopupService) {
      PopupService = _webAtomsCoreDistWebServicesPopupService.default;
      PopupWindow = _webAtomsCoreDistWebServicesPopupService.PopupWindow;
    }, function (_basicFormField) {
      FormField = _basicFormField.default;
    }, function (_CommandButton) {
      CommandButton = _CommandButton.default;
    }, function (_HtmlCommands) {
      HtmlCommands = _HtmlCommands.default;
    }],
    execute: function () {
      ImageDialog = class ImageDialog extends PopupWindow {
        create() {
          this.link = "";
          this.alt = "";
          this.render(XNode.create("div", null, XNode.create(FormField, {
            label: "Url"
          }, XNode.create("input", {
            value: Bind.twoWaysImmediate(() => this.link)
          })), XNode.create(FormField, {
            label: "Alt"
          }, XNode.create("input", {
            value: Bind.twoWaysImmediate(() => this.alt)
          })), XNode.create("div", {
            class: "command-bar"
          }, XNode.create("button", {
            eventClick: () => this.close(this.createImage()),
            text: "Add"
          }))));
        }
        createImage() {
          if (this.alt) {
            return `<img src="${this.link}" alt="${this.alt}" />`;
          }
          return `<img src="${this.link}"/>`;
        }
      };
      __decorate([BindableProperty, __metadata("design:type", String)], ImageDialog.prototype, "link", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], ImageDialog.prototype, "alt", void 0);
    }
  };
});
//# sourceMappingURL=AddImage.js.map