System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomToggleButtonBar", "@web-atoms/core/dist/web/services/PopupService", "../../basic/FormField", "./CommandButton", "./HtmlCommands", "./AddLink.local.css"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, Bind, BindableProperty, XNode, AtomToggleButtonBar, PopupService, PopupWindow, FormField, CommandButton, HtmlCommands, LinkDialog, linkTypes, linkDialogCss;
  function showDialog(s, e) {
    return PopupService.showWindow(s.element, LinkDialog);
  }
  function AddLink({
    insertCommand = HtmlCommands.createLink
  }) {
    return CommandButton({
      icon: "ri-link-m",
      insertCommand,
      disabled: false,
      eventInsertHtml: showDialog,
      title: "Create Hyper Link"
    });
  }
  _export("default", AddLink);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomToggleButtonBar) {
      AtomToggleButtonBar = _webAtomsCoreDistWebControlsAtomToggleButtonBar.AtomToggleButtonBar;
    }, function (_webAtomsCoreDistWebServicesPopupService) {
      PopupService = _webAtomsCoreDistWebServicesPopupService.default;
      PopupWindow = _webAtomsCoreDistWebServicesPopupService.PopupWindow;
    }, function (_basicFormField) {
      FormField = _basicFormField.default;
    }, function (_CommandButton) {
      CommandButton = _CommandButton.default;
    }, function (_HtmlCommands) {
      HtmlCommands = _HtmlCommands.default;
    }, function (_AddLinkLocalCss) {}],
    execute: function () {
      linkTypes = [{
        label: "Web Page",
        value: "web-page"
      }, {
        label: "Email",
        value: "email"
      }, {
        label: "Anchor",
        value: "anchor"
      }, {
        label: "Phone",
        value: "phone"
      }];
      linkDialogCss = "html-editor-commands-add-link";
      LinkDialog = class LinkDialog extends PopupWindow {
        create() {
          this.type = "web-page";
          this.title = "Create Link";
          this.render(XNode.create("div", {
            class: linkDialogCss
          }, XNode.create(FormField, {
            label: "Type"
          }, XNode.create(AtomToggleButtonBar, {
            items: linkTypes,
            value: Bind.twoWays(() => this.type)
          })), XNode.create(FormField, {
            label: "Link",
            required: true
          }, XNode.create("input", {
            placeholder: "https://...",
            value: Bind.twoWaysImmediate(() => this.link)
          })), XNode.create("div", {
            class: "command-bar"
          }, XNode.create("button", {
            text: "Add",
            eventClick: Bind.event(() => this.close(this.toLink(this.link)))
          }))));
        }
        toLink(link) {
          switch (this.type) {
            case "web-page":
              return /^(http|https)\:\/\//.test(link) ? link : `http://${link}`;
          }
        }
      };
      __decorate([BindableProperty, __metadata("design:type", String)], LinkDialog.prototype, "link", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], LinkDialog.prototype, "type", void 0);
    }
  };
});
//# sourceMappingURL=AddLink.js.map