System.register(["@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/XNode", "../../basic/PopupButton", "./ChangeFont.local.css"], function (_export, _context) {
  "use strict";

  var Bind, XNode, PopupButton, MenuItem, fontMenuCSS, fonts;
  function FontMenu({
    name,
    value
  }) {
    const cssName = value.join(" ");
    return XNode.create("div", {
      class: "menu",
      eventClick: Bind.event(e => e.executeCommand("fontName", false, cssName))
    }, XNode.create("i", {
      class: Bind.oneWay(e => ({
        "ri-check-line": 1,
        "selected": e.getStyle("fontFamily", e.version).toLowerCase().indexOf(value[0].toLowerCase()) !== -1
      }))
    }), XNode.create("label", {
      styleFontFamily: name
    }, name));
  }
  function selectFont(name) {
    if (name === null || name === void 0) {
      return "Font";
    }
    for (const [display, value] of fonts) {
      for (const iterator of value) {
        if (name.indexOf(iterator) !== -1) {
          return display;
        }
      }
    }
    return "Font";
  }
  function ChangeFont() {
    return XNode.create(PopupButton, {
      class: "command",
      "data-layout": "toolbar-button",
      text: Bind.oneWay(e => selectFont(e.getStyle("fontFamily", e.version))),
      title: "Change Font"
    }, XNode.create("div", {
      class: fontMenuCSS
    }, ...fonts.map(([name, value]) => XNode.create(MenuItem, {
      "style-font-family": name,
      icon: Bind.oneWay(e => selectFont(e.getStyle("fontFamily", e.version)).toLowerCase().indexOf(value[0].toLowerCase()) !== -1 ? "ri-check-line selected" : ""),
      label: name,
      eventClick: Bind.event(e => e.executeCommand("fontName", false, value.join(" ")))
    }))));
  }
  _export({
    FontMenu: FontMenu,
    default: ChangeFont
  });
  return {
    setters: [function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_basicPopupButton) {
      PopupButton = _basicPopupButton.default;
      MenuItem = _basicPopupButton.MenuItem;
    }, function (_ChangeFontLocalCss) {}],
    execute: function () {
      fontMenuCSS = "web-controls-html-editor-change-font";
      fonts = [["Sans Serif", ["arial", "sans-serif"]], ["Serif", [`"times new roman"`, "serif"]], ["Fixed Width", ["monospace"]], ["Wide", [`"arial black"`, "sans-serif"]], ["Narrow", [`"arial narrow"`, "sans-serif"]], ["Comic Sans MS", [`"comic sans ms"`, "sans-serif"]], ["Garamond", ["garamond", `"times new roman"`, "serif"]], ["Georgia", ["georgia"]], ["Tahoma", ["tahoma"]], ["Trebuchet MS", [`"trebuchet ms"`]], ["Verdana", ["verdana"]]];
    }
  };
});
//# sourceMappingURL=ChangeFont.js.map