System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/XNode"], function (_export, _context) {
  "use strict";

  var __awaiter, Bind, XNode;
  function notSet(text) {
    return () => {
      alert(`Command ${text} not set`);
    };
  }
  function insert(callback, command) {
    return (s, e) => __awaiter(this, void 0, void 0, function* () {
      let r = callback(s, e);
      if (typeof r !== "string") {
        if (r === null || r === void 0 ? void 0 : r.then) {
          r = yield r;
        }
      }
      if (r) {
        if (command) {
          command.execute(s, false, r);
        } else {
          s.executeCommand("insertHTML", false, r);
        }
      }
    });
  }
  function CommandButton({
    icon,
    label,
    eventInsertHtml,
    insertCommand,
    title,
    disabled
  }) {
    disabled !== null && disabled !== void 0 ? disabled : disabled = Bind.oneWay(x => x.version ? !insertCommand.canExecute(x) : false);
    if (label) {
      return XNode.create("button", {
        class: "command",
        "data-layout": "toolbar-button",
        disabled: disabled,
        eventClick: Bind.event(insert(eventInsertHtml, insertCommand)),
        title: title
      }, XNode.create("label", {
        class: "label"
      }, XNode.create("i", {
        class: icon
      }), XNode.create("span", {
        text: label
      })));
    }
    return XNode.create("button", {
      "data-layout": "toolbar-button",
      title: title,
      class: "command",
      disabled: disabled,
      eventClick: Bind.event(insert(eventInsertHtml, insertCommand))
    }, XNode.create("i", {
      class: icon
    }));
  }
  _export({
    notSet: notSet,
    default: CommandButton
  });
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }],
    execute: function () {}
  };
});
//# sourceMappingURL=CommandButton.js.map