import type AtomHtmlEditor from "../AtomHtmlEditor";
export interface IHtmlCommand {
    canExecute(e: AtomHtmlEditor): boolean;
    execute(e: AtomHtmlEditor, showUI?: boolean, value?: string): boolean;
}
export default class HtmlCommands {
    static backColor: IHtmlCommand;
    static bold: IHtmlCommand;
    static contentReadOnly: IHtmlCommand;
    static copy: IHtmlCommand;
    static createLink: IHtmlCommand;
    static cut: IHtmlCommand;
    static decreaseFontSize: IHtmlCommand;
    static defaultParagraphSeparator: IHtmlCommand;
    static enableAbsolutePositionEditor: IHtmlCommand;
    static enableInlineTableEditing: IHtmlCommand;
    static enableObjectResizing: IHtmlCommand;
    static fontName: IHtmlCommand;
    static fontSize: IHtmlCommand;
    static foreColor: IHtmlCommand;
    static formatBlock: IHtmlCommand;
    static forwardDelete: IHtmlCommand;
    static heading: IHtmlCommand;
    static hiliteColor: IHtmlCommand;
    static increaseFontSize: IHtmlCommand;
    static indent: IHtmlCommand;
    static insertBrOnReturn: IHtmlCommand;
    static insertHorizontalRule: IHtmlCommand;
    static insertHTML: IHtmlCommand;
    static insertImage: IHtmlCommand;
    static insertOrderedList: IHtmlCommand;
    static insertUnorderedList: IHtmlCommand;
    static insertParagraph: IHtmlCommand;
    static insertText: IHtmlCommand;
    static italic: IHtmlCommand;
    static justifyCenter: IHtmlCommand;
    static justifyFull: IHtmlCommand;
    static justifyLeft: IHtmlCommand;
    static justifyRight: IHtmlCommand;
    static outdent: IHtmlCommand;
    static paste: IHtmlCommand;
    static redo: IHtmlCommand;
    static removeFormat: IHtmlCommand;
    static selectAll: IHtmlCommand;
    static strikeThrough: IHtmlCommand;
    static subscript: IHtmlCommand;
    static superscript: IHtmlCommand;
    static underline: IHtmlCommand;
    static undo: IHtmlCommand;
    static unlink: IHtmlCommand;
    static useCSS: IHtmlCommand;
    static styleWithCSS: IHtmlCommand;
    static AutoUrlDetect: IHtmlCommand;
    static enabled: {
        canExecute(e: any): boolean;
        execute(): never;
    };
}
//# sourceMappingURL=HtmlCommands.d.ts.map