System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/services/PopupService", "./CommandButton", "./HtmlCommands", "./Source.local.css"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, Bind, BindableProperty, XNode, PopupService, PopupWindow, CommandButton, HtmlCommands, css;
  function showDialog(s, e) {
    return __awaiter(this, void 0, void 0, function* () {
      class SourceDialog extends PopupWindow {
        create() {
          this.source = s.htmlContent;
          this.render(XNode.create("div", {
            class: css
          }, XNode.create("textarea", {
            value: Bind.twoWaysImmediate(() => this.source)
          }), XNode.create("div", {
            class: "command-bar"
          }, XNode.create("button", {
            eventClick: Bind.event(() => this.close(this.source)),
            text: "Save"
          }))));
        }
      }
      __decorate([BindableProperty, __metadata("design:type", String)], SourceDialog.prototype, "source", void 0);
      const result = yield PopupService.showWindow(s.element, SourceDialog);
      s.htmlContent = result;
      return null;
    });
  }
  function Source({
    insertCommand = HtmlCommands.enabled
  }) {
    return CommandButton({
      icon: "ri-edit-box-fill",
      insertCommand,
      eventInsertHtml: showDialog,
      title: "Edit Source Code"
    });
  }
  _export("default", Source);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebServicesPopupService) {
      PopupService = _webAtomsCoreDistWebServicesPopupService.default;
      PopupWindow = _webAtomsCoreDistWebServicesPopupService.PopupWindow;
    }, function (_CommandButton) {
      CommandButton = _CommandButton.default;
    }, function (_HtmlCommands) {
      HtmlCommands = _HtmlCommands.default;
    }, function (_SourceLocalCss) {}],
    execute: function () {
      css = "web-controls-html-editor-source";
    }
  };
});
//# sourceMappingURL=Source.js.map