System.register(["../PageNavigator", "./MobileApp", "@web-atoms/core/dist/web/core/AtomUI", "../basic/AtomRepeater", "./MasterDetailPage.global.css"], function (_export, _context) {
  "use strict";

  var PageNavigator, ContentPage, isMobileView, descendentElementIterator, AtomRepeater, MasterDetailPage, findItem;
  _export("default", void 0);
  return {
    setters: [function (_PageNavigator) {
      PageNavigator = _PageNavigator.default;
    }, function (_MobileApp) {
      ContentPage = _MobileApp.ContentPage;
      isMobileView = _MobileApp.isMobileView;
    }, function (_webAtomsCoreDistWebCoreAtomUI) {
      descendentElementIterator = _webAtomsCoreDistWebCoreAtomUI.descendentElementIterator;
    }, function (_basicAtomRepeater) {
      AtomRepeater = _basicAtomRepeater.default;
    }, function (_MasterDetailPageGlobalCss) {}],
    execute: function () {
      findItem = (content, item) => {
        var _a, _b, _c;
        for (const iterator of descendentElementIterator(content)) {
          const repeater = iterator === null || iterator === void 0 ? void 0 : iterator.atomControl;
          if (!(repeater instanceof AtomRepeater)) {
            continue;
          }
          const index = (_b = (_a = repeater.items) === null || _a === void 0 ? void 0 : _a.indexOf(item)) !== null && _b !== void 0 ? _b : -1;
          if (index === -1) {
            continue;
          }
          const element = (_c = repeater.element) === null || _c === void 0 ? void 0 : _c.querySelector(`[data-item-index="${index}"]`);
          if (element) {
            return element;
          }
        }
      };
      _export("default", MasterDetailPage = class MasterDetailPage extends ContentPage {
        constructor() {
          super(...arguments);
          this.showClose = true;
          this.scrollEveryNewTarget = false;
          this.lookupItemForHighlight = true;
          this.highlightAttributeValue = ["data-filter", "drop-shadow-accent"];
        }
        get highlightAttribute() {
          return this.highlightAttributeValue;
        }
        set highlightAttribute(value) {
          var _a;
          if (!value) {
            this.highlightAttributeValue = ["data-filter", "drop-shadow-accent"];
            return;
          }
          if (typeof value === "string") {
            const tokens = value.split("=");
            let key = tokens[0];
            let v = (_a = tokens[1]) !== null && _a !== void 0 ? _a : "true";
            if (v.endsWith("]")) {
              v = v.substring(0, v.length - 1);
            }
            if (key.startsWith("[")) {
              key = key.substring(1);
            }
            value = [key, v];
          }
          this.highlightAttributeValue = value;
        }
        openDetail(page, parameters, highlightElementOrItem) {
          if (isMobileView) {
            PageNavigator.pushPage(page, parameters);
            return;
          }
          const content = this.element.querySelector(`[data-page-element="content"]`);
          content.setAttribute("data-mode", "desktop");
          this.element.setAttribute("data-is-open", "true");
          let highlightElement;
          if (highlightElementOrItem instanceof HTMLElement) {
            highlightElement = highlightElementOrItem;
          }
          if (!highlightElement && this.lookupItemForHighlight) {
            highlightElement = findItem(content, highlightElementOrItem);
          }
          const lastTargetElement = this.lastTargetElement;
          if (lastTargetElement) {
            const [key] = this.highlightAttributeValue;
            lastTargetElement.removeAttribute(key);
          }
          this.lastTargetElement = highlightElement;
          if (!this.closeButton && this.showClose) {
            const closeButton = document.createElement("i");
            closeButton.setAttribute("data-element", "close");
            closeButton.className = "fas fa-times-circle";
            this.closeButton = closeButton;
            this.element.appendChild(closeButton);
            closeButton.addEventListener("click", () => this.closeDetail());
          }
          let lastDetail = this.lastDetail;
          if (lastDetail) {
            const {
              element
            } = lastDetail;
            lastDetail.dispose();
            element.remove();
            if (this.scrollEveryNewTarget) {
              this.scrollTargetIntoView();
            }
          } else {
            this.scrollTargetIntoView();
          }
          this.updateTargetSelector(highlightElement);
          const P = page;
          lastDetail = new P(this.app);
          this.element.appendChild(lastDetail.element);
          lastDetail.element.setAttribute("data-element", "detail");
          this.lastDetail = lastDetail;
          lastDetail.parameters = parameters;
          const close = () => this.closeDetail();
          lastDetail.cancel = close;
          lastDetail.close = close;
          this.app.runAsync(() => {
            var _a, _b;
            return (_b = (_a = this.lastDetail) === null || _a === void 0 ? void 0 : _a.init) === null || _b === void 0 ? void 0 : _b.call(_a);
          });
        }
        scrollTargetIntoView(dispose = false) {
          const lastTargetElement = this.lastTargetElement;
          if (lastTargetElement) {
            setTimeout(() => {
              if (lastTargetElement.isConnected) {
                lastTargetElement.scrollIntoView();
              }
              if (dispose) {
                this.lastTargetElement = void 0;
                this.updateTargetSelector(lastTargetElement, true, dispose);
              }
            }, 100);
          }
        }
        updateTargetSelector(lastTargetElement, remove = false, delay = false) {
          if (!lastTargetElement) {
            return;
          }
          const [key, value] = this.highlightAttributeValue;
          if (remove) {
            if (delay) {
              setTimeout(() => {
                lastTargetElement.removeAttribute(key);
              }, 1000);
            } else {
              lastTargetElement.removeAttribute(key);
            }
            return;
          }
          lastTargetElement.setAttribute(key, value);
        }
        preCreate() {
          super.preCreate();
          if (!isMobileView) {
            this.element.setAttribute("data-mode", "desktop");
          }
          this.element.setAttribute("data-page-type", "master-detail");
        }
        closeDetail() {
          const lastDetail = this.lastDetail;
          if (lastDetail) {
            const {
              element
            } = lastDetail;
            lastDetail.dispose();
            element.remove();
            this.lastDetail = void 0;
          }
          const closeButton = this.closeButton;
          if (closeButton) {
            closeButton.remove();
            this.closeButton = void 0;
          }
          const content = this.element.querySelector(`[data-page-element="content"]`);
          content.removeAttribute("data-mode");
          this.element.removeAttribute("data-is-open");
          this.scrollTargetIntoView(true);
        }
      });
    }
  };
});
//# sourceMappingURL=MasterDetailPage.js.map