System.register(["tslib", "@web-atoms/core/dist/Atom", "@web-atoms/core/dist/core/AtomBinder", "@web-atoms/core/dist/core/AtomUri", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/di/Inject", "@web-atoms/core/dist/services/NavigationService", "@web-atoms/core/dist/view-model/AtomViewModel"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, Atom, AtomBinder, AtomUri, CancelToken, Inject, NavigationService, AtomViewModel, Receive, Watch, PageFrameViewModel;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistAtom) {
      Atom = _webAtomsCoreDistAtom.Atom;
    }, function (_webAtomsCoreDistCoreAtomBinder) {
      AtomBinder = _webAtomsCoreDistCoreAtomBinder.AtomBinder;
    }, function (_webAtomsCoreDistCoreAtomUri) {
      AtomUri = _webAtomsCoreDistCoreAtomUri.AtomUri;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistDiInject) {
      Inject = _webAtomsCoreDistDiInject.Inject;
    }, function (_webAtomsCoreDistServicesNavigationService) {
      NavigationService = _webAtomsCoreDistServicesNavigationService.NavigationService;
    }, function (_webAtomsCoreDistViewModelAtomViewModel) {
      AtomViewModel = _webAtomsCoreDistViewModelAtomViewModel.AtomViewModel;
      Receive = _webAtomsCoreDistViewModelAtomViewModel.Receive;
      Watch = _webAtomsCoreDistViewModelAtomViewModel.Watch;
    }],
    execute: function () {
      _export("default", PageFrameViewModel = class PageFrameViewModel extends AtomViewModel {
        constructor() {
          super(...arguments);
          this.owner = null;
          this.title = "Mobile Page";
        }
        get canGoBack() {
          if (!this.owner) {
            return false;
          }
          return this.owner.stack.length > 0;
        }
        get url() {
          return this.mUrl;
        }
        set url(value) {
          if (value === this.mUrl) {
            return;
          }
          this.mUrl = value;
          this.owner.pushUrl(value);
          if (this.app.url.hash.url !== value) {
            this.app.url.hash.url = value;
            history.pushState({}, document.title, this.app.url.toString());
          }
          this.refresh("url");
        }
        init() {
          return __awaiter(this, void 0, void 0, function* () {
            yield Atom.delay(1);
            if (!this.owner.name) {
              return;
            }
            if (this.owner.url) {
              this.app.url.hash.url = this.owner.url;
              this.mUrl = this.owner.url;
              history.pushState({}, document.title, this.app.url.toString());
            } else {
              const url = this.app.url ? this.app.url.query.url || this.app.url.query.url : null;
              if (url) {
                this.url = url.toString();
              }
            }
            if (typeof dotNet === "undefined") {
              this.owner.bindEvent(window, "popstate", () => this.onPopState());
            } else {
              window.addEventListener("backButton", ce => {
                const {
                  detail
                } = ce;
                ce.preventDefault();
                this.app.runAsync(() => __awaiter(this, void 0, void 0, function* () {
                  if (this.owner.stack.length) {
                    yield this.iconClick();
                  } else {
                    detail();
                  }
                }));
              });
            }
          });
        }
        iconClick() {
          return __awaiter(this, void 0, void 0, function* () {
            if (this.cancelToken) {
              this.cancelToken.cancel();
              this.cancelToken = null;
              return;
            }
            if (this.owner.keepStack && this.owner.stack.length) {
              const p = this.owner.backCommand();
              if (p && p.then && p.catch) {
                yield p;
              }
              setTimeout(() => {
                AtomBinder.refreshValue(this, "canGoBack");
              }, 500);
              return;
            }
            if (!this.owner.menuUrl) {
              return;
            }
            this.cancelToken = new CancelToken();
            this.navigationService.openPage(this.owner.menuUrl, null, {
              cancelToken: this.cancelToken
            }).then(() => this.cancelToken = null).catch(() => this.cancelToken = null);
          });
        }
        onPopState() {
          this.app.url = new AtomUri(location.href);
          const url = this.app.url.hash.url || this.app.url.query.url;
          if (url === this.mUrl) {
            return;
          }
          const stack = this.owner.stack;
          if (stack.length && stack[stack.length - 1].url === url) {
            this.owner.backCommand();
            return;
          }
          this.owner.url = url;
        }
      });
      __decorate([Watch, __metadata("design:type", Boolean), __metadata("design:paramtypes", [])], PageFrameViewModel.prototype, "canGoBack", null);
      __decorate([Inject, __metadata("design:type", NavigationService)], PageFrameViewModel.prototype, "navigationService", void 0);
      __decorate([Receive("root-page-go-back"), __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", Promise)], PageFrameViewModel.prototype, "iconClick", null);
    }
  };
});
//# sourceMappingURL=PageFrameViewModel.js.map