System.register(["tslib", "@web-atoms/core/dist/core/AtomBinder", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/core/AtomUI", "./AtomVideoPlayer.global.css"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, AtomBinder, Bind, BindableProperty, XNode, AtomControl, ChildEnumerator, AtomVideoPlayer, isTouchEnabled, gatherElements, numberToText, durationText, noSoundIcon, mute, low, mid, high, getPlayIcon;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreAtomBinder) {
      AtomBinder = _webAtomsCoreDistCoreAtomBinder.AtomBinder;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebCoreAtomUI) {
      ChildEnumerator = _webAtomsCoreDistWebCoreAtomUI.ChildEnumerator;
    }, function (_AtomVideoPlayerGlobalCss) {}],
    execute: function () {
      isTouchEnabled = /android|iPhone|iPad/i.test(navigator.userAgent);
      gatherElements = (e, data = {}) => {
        var _a;
        const ce = ChildEnumerator.enumerate(e);
        for (const iterator of ce) {
          const elementName = (_a = iterator.dataset.element) === null || _a === void 0 ? void 0 : _a.replace(/-([a-z])/g, g => g[1].toUpperCase());
          if (elementName) {
            data[elementName] = iterator;
          }
          gatherElements(iterator, data);
        }
        return data;
      };
      numberToText = n => {
        if (n < 10) {
          return "0" + n;
        }
        return n.toString();
      };
      durationText = (n, total) => {
        if (n === null || n === undefined) {
          return "";
        }
        const minutes = Math.floor(n / 60);
        const seconds = numberToText(Math.ceil(n % 60));
        const totalMinutes = Math.floor(total / 60);
        const totalSeconds = numberToText(Math.ceil(total % 60));
        return `${minutes}:${seconds} / ${totalMinutes}:${totalSeconds}`;
      };
      noSoundIcon = "fa-duotone fa-volume-slash";
      mute = "fa-duotone fa-volume-xmark";
      low = "fa-duotone fa-volume-low";
      mid = "fa-duotone fa-volume";
      high = "fa-duotone fa-volume-high";
      getPlayIcon = state => {
        switch (state) {
          case "ended":
            return "fa-solid fa-refresh";
          case "paused":
            return "fa-solid fa-play";
          case "playing":
            return "fa-solid fa-pause";
        }
        return "fa-solid fa-play";
      };
      _export("default", AtomVideoPlayer = class AtomVideoPlayer extends AtomControl {
        constructor() {
          super(...arguments);
          this.maxWidth = "";
        }
        get poster() {
          return this.video.poster;
        }
        set poster(v) {
          this.video.poster = v;
        }
        get state() {
          return this.element.getAttribute("data-state");
        }
        set state(v) {
          this.element.setAttribute("data-state", v);
          AtomBinder.refreshValue(this, "paused");
          AtomBinder.refreshValue(this, "state");
        }
        get duration() {
          return this.video.duration;
        }
        get time() {
          return this.video.currentTime;
        }
        set time(v) {
          this.video.currentTime = v;
        }
        get paused() {
          return this.video.paused;
        }
        get isFullScreen() {
          var _a;
          return (_a = document.fullscreenEnabled && this.element === document.fullscreenElement) !== null && _a !== void 0 ? _a : false;
        }
        stopFullscreen() {
          if (this.isFullScreen) {
            return document.exitFullscreen();
          }
          return Promise.resolve();
        }
        pause() {
          this.video.pause();
        }
        play() {
          this.video.play().catch(console.error);
        }
        onPropertyChanged(name) {
          switch (name) {
            case "source":
              this.updateSource();
              break;
          }
        }
        setCurrentTime(n) {
          this.video.currentTime = n * this.video.duration;
        }
        create() {
          this.element.dataset.videoPlayer = "video-player";
          this.bindEvent(this.element, "togglePlay", e => {
            if (e.defaultPrevented) {
              return;
            }
            e.preventDefault();
            if (isTouchEnabled) {
              if (this.state === "playing") {
                if (e.target === this.video) {
                  if (this.element.dataset.controls === "true") {
                    this.element.dataset.controls = "false";
                  } else {
                    this.element.dataset.controls = "true";
                  }
                  return;
                }
              }
              if (e.target.tagName === "CANVAS") {
                return;
              }
            }
            if (this.video.paused) {
              this.video.play();
              this.element.dataset.controls = "false";
            } else {
              this.video.pause();
              this.element.dataset.controls = "true";
            }
          });
          this.bindEvent(this.element, "volume", e => {
            this.video.muted = !this.video.muted;
            this.updateVolume();
          });
          this.bindEvent(this.element, "fullScreen", e => __awaiter(this, void 0, void 0, function* () {
            if (!this.element.requestFullscreen) {
              this.video.webkitEnterFullscreen();
              return;
            }
            if (this.isFullScreen) {
              yield document.exitFullscreen();
              return;
            }
            yield this.element.requestFullscreen({
              navigationUI: "show"
            });
          }));
          this.bindEvent(document, "fullscreenchange", () => {
            AtomBinder.refreshValue(this, "isFullScreen");
          });
          this.render(XNode.create("div", {
            "data-click-event": "toggle-play",
            "data-state": "pause"
          }, XNode.create("div", {
            "data-has-logo": Bind.oneWay(() => this.logo ? "true" : "false", "false"),
            "data-element": "banner",
            "style-width": Bind.oneWay(() => this.maxWidth)
          }, XNode.create("img", {
            "data-element": "logo",
            src: Bind.oneWay(() => this.logo)
          }), XNode.create("div", {
            "data-element": "logo-title",
            text: Bind.oneWay(() => this.logo && this.logoTitle)
          }), XNode.create("div", {
            "data-element": "logo-description",
            text: Bind.oneWay(() => this.logo && this.logoDescription)
          })), XNode.create("video", {
            "event-abort": () => this.state = "aborted",
            "event-durationchange": e => AtomBinder.refreshValue(this, "duration"),
            "event-ended": e => __awaiter(this, void 0, void 0, function* () {
              this.state = "ended";
              if (document.fullscreenEnabled && this.element === document.fullscreenElement) {
                yield document.exitFullscreen();
              }
              e.target.dispatchEvent(new CustomEvent("videoEnded", {
                bubbles: true
              }));
            }),
            "event-loadedmetadata": () => {
              this.updateVolume();
              this.currentTimeSpan.textContent = durationText(0, this.duration);
              this.updateProgress();
              const {
                video
              } = this;
              const {
                videoWidth,
                videoHeight
              } = video;
              const eW = video.offsetWidth * videoHeight / videoWidth;
              const maxWidth = 100 * (this.element.offsetWidth - eW) / this.element.offsetWidth;
              if (maxWidth > 50 && maxWidth < 100) {
                this.maxWidth = `${maxWidth}%`;
              }
              AtomBinder.refreshValue(this, "duration");
            },
            "event-pause": () => this.state = "paused",
            "event-play": () => this.state = "playing",
            "event-progress": () => this.updateProgress(),
            "event-timeupdate": () => {
              this.currentTimeSpan.textContent = durationText(this.time, this.duration);
              this.state = "playing";
              this.updateProgress();
              AtomBinder.refreshValue(this, "time");
            },
            "event-waiting": () => this.state = "waiting",
            "event-volumechange": () => this.updateVolume(),
            autoplay: false,
            playsInline: true,
            "style-max-width": "100%",
            "style-max-height": "100%",
            "data-element": "video"
          }), XNode.create("canvas", {
            "data-element": "progress"
          }), XNode.create("img", {
            "data-element": "poster"
          }), XNode.create("div", {
            "data-element": "toolbar"
          }, XNode.create("i", {
            "data-element": "play",
            "data-style": "button",
            class: Bind.oneWay(() => getPlayIcon(this.state))
          }), XNode.create("i", {
            "data-click-event": "volume",
            "data-style": "button",
            "data-element": "sound",
            class: "fa-duotone fa-volume-slash"
          }), !isTouchEnabled && XNode.create("input", {
            "data-click-event": "none",
            "data-element": "volume-range",
            type: "range",
            min: 0,
            max: 1,
            step: 0.1
          }), XNode.create("span", {
            "data-font-size": "small",
            "data-element": "current",
            text: "0:00"
          }), XNode.create("i", {
            "data-click-event": "full-screen",
            "data-style": "button",
            "data-element": "full-screen",
            class: Bind.oneWay(() => this.isFullScreen ? "fa-solid fa-compress" : "fa-solid fa-expand")
          })), XNode.create("div", {
            "data-click-event": "toggle-play",
            "data-element": "play-element"
          }, XNode.create("button", {
            class: "play"
          }, XNode.create("i", {
            class: Bind.oneWay(() => getPlayIcon(this.state))
          })))));
          const all = gatherElements(this.element);
          this.video = all.video;
          this.progress = all.progress;
          this.currentTimeSpan = all.current;
          this.soundIcon = all.sound;
          this.volumeRange = all.volumeRange;
          if (this.volumeRange) {
            this.bindEvent(this.volumeRange, "input", () => {
              setTimeout(() => {
                this.video.volume = parseFloat(this.volumeRange.value);
              }, 1);
            });
          }
          this.bindEvent(this.element, "mouseenter", () => {
            this.element.dataset.controls = "true";
          });
          this.bindEvent(this.element, "mouseleave", () => {
            this.element.dataset.controls = "false";
          });
          this.bindEvent(this.progress, "pointerdown", e => {
            e.preventDefault();
            this.setCurrentTime(e.offsetX / this.progress.clientWidth);
            const move = e1 => {
              e1.preventDefault();
              this.setCurrentTime(e1.offsetX / this.progress.clientWidth);
            };
            const up = e1 => {
              e1.preventDefault();
              this.progress.removeEventListener("pointermove", move);
              this.progress.removeEventListener("pointerup", up);
            };
            this.progress.addEventListener("pointermove", move);
            this.progress.addEventListener("pointerup", up);
          });
        }
        updateSource() {
          this.video.src = this.source;
        }
        updateProgress() {
          const context = this.progress.getContext("2d");
          context.strokeStyle = "rgba(0,0,0,0)";
          const width = this.progress.clientWidth;
          const height = this.progress.clientHeight;
          this.progress.width = width;
          this.progress.height = height;
          context.clearRect(0, 0, width, height);
          const max = this.video.duration;
          const seekable = this.video.buffered;
          const scale = width / max;
          context.fillStyle = "rgba(255,255,255,0.3)";
          context.fillRect(0, 0, width, height);
          context.fillStyle = "rgba(255,255,255,0.6)";
          for (let index = 0; index < seekable.length; index++) {
            const start = seekable.start(index) * scale;
            const end = seekable.end(index) * scale;
            context.fillRect(start, 0, end, height);
          }
          context.fillStyle = "#ffffff";
          context.fillRect(0, 0, this.video.currentTime * scale, height);
        }
        updateVolume() {
          if (this.video.muted) {
            this.soundIcon.className = mute;
            this.soundIcon.title = "Unmute";
            if (this.volumeRange) {
              this.volumeRange.style.display = "none";
            }
            return;
          }
          const audio = this.video.volume;
          if (this.volumeRange) {
            this.volumeRange.style.display = "";
            this.volumeRange.value = audio === null || audio === void 0 ? void 0 : audio.toString();
          }
          this.soundIcon.title = "Mute";
          if (audio > 0.8) {
            this.soundIcon.className = high;
            return;
          }
          if (audio < 0.2) {
            this.soundIcon.className = low;
            return;
          }
          this.soundIcon.className = mid;
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Object)], AtomVideoPlayer.prototype, "source", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], AtomVideoPlayer.prototype, "logo", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomVideoPlayer.prototype, "logoTitle", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomVideoPlayer.prototype, "logoDescription", void 0);
    }
  };
});
//# sourceMappingURL=AtomVideoPlayer.js.map