System.register(["tslib", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "../basic/styles/toggle-view.global.css", "@web-atoms/core/dist/view-model/Action"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, __rest, BindableProperty, XNode, AtomControl, Action;
  function ToggleView({
    icon,
    label
  }, ...nodes) {
    return XNode.create("div", null, XNode.create("div", null, XNode.create("i", {
      class: icon
    }), XNode.create("label", {
      text: label
    })), XNode.create("div", null, ...nodes));
  }
  function AtomToggleView(_a, ...nodes) {
    var _b, _c;
    var {
        selectedIndex
      } = _a,
      a = __rest(_a, ["selectedIndex"]);
    const headers = [];
    const views = [];
    let n = 0;
    for (const iterator of nodes) {
      const i = n++;
      const header = iterator.children[0];
      const ha = (_b = header.attributes) !== null && _b !== void 0 ? _b : header.attributes = {};
      ha["data-element"] = "header";
      ha["data-click-event"] = "header-click";
      ha["data-header-index"] = i.toString();
      const view = iterator.children[1];
      const a = (_c = view.attributes) !== null && _c !== void 0 ? _c : view.attributes = {};
      a["data-element"] = "view";
      a["data-left"] = i < selectedIndex;
      a["data-right"] = i > selectedIndex;
      a["data-selected"] = i === selectedIndex;
      headers.push(header);
      views.push(view);
    }
    class AtomToggleViewControl extends AtomControl {
      onPropertyChanged(name) {
        super.onPropertyChanged(name);
        if (name === "selectedIndex") {
          this.updateViews();
        }
      }
      preCreate() {
        this.selectedIndex = 0;
        this.runAfterInit(() => this.updateViews());
      }
      onHeaderClick({
        headerIndex
      }) {
        this.selectedIndex = parseInt(headerIndex, 0);
      }
      updateViews() {
        const pe = this.element.parentElement;
        if (!pe) {
          return;
        }
        let ai = 0;
        for (const child of Array.from(pe.querySelectorAll(`[data-element="view"]`))) {
          const i = ai++;
          child.setAttribute("data-left", (i < this.selectedIndex).toString());
          child.setAttribute("data-right", (i > this.selectedIndex).toString());
          child.setAttribute("data-selected", (i === this.selectedIndex).toString());
        }
        ai = 0;
        for (const child of Array.from(pe.querySelectorAll(`[data-element="header"]`))) {
          const i = ai++;
          child.setAttribute("data-selected", (i === this.selectedIndex).toString());
        }
      }
    }
    __decorate([BindableProperty, __metadata("design:type", Number)], AtomToggleViewControl.prototype, "selectedIndex", void 0);
    __decorate([Action({
      onEvent: "header-click"
    }), __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], AtomToggleViewControl.prototype, "onHeaderClick", null);
    return XNode.create("div", Object.assign({}, a, {
      "data-wa-toggle-view": "wa-toggle-view"
    }), XNode.create(AtomToggleViewControl, {
      class: "toolbar"
    }, ...headers), ...views);
  }
  _export({
    ToggleView: ToggleView,
    default: AtomToggleView
  });
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_basicStylesToggleViewGlobalCss) {}, function (_webAtomsCoreDistViewModelAction) {
      Action = _webAtomsCoreDistViewModelAction.default;
    }],
    execute: function () {}
  };
});
//# sourceMappingURL=AtomToggleView.js.map